<?php
// ====================================================================
// Copyright (c) 2010 The Regents of the University of Michigan and 
// The European Organization for Nuclear Research (CERN). Licensed under the
// Educational Community License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License. You may
// obtain a copy of the License at
//
// http://www.osedu.org/licenses/ECL-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an "AS IS"
// BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing
// permissions and limitations under the License.
// ====================================================================

//path to the place where the logs are stored
$PATH_TO_LOG_LOCATION = 'flashLogs/';


//get list of files in dir
$flashLogArray = scandir($PATH_TO_LOG_LOCATION);


//_MASTER variables
$_MASTER_duration = 0;
$_MASTER_transportDuration = 0;
$_MASTER_playheadDuration = 0;
$_MASTER_previewDuration = 0;
$_MASTER_slideClickNumber = 0;
$_MASTER_seekBarClickNumber = 0;
$_MASTER_seekBarDragNumber = 0;
$_MASTER_layout_1_time = 0;
$_MASTER_layout_2_time = 0;
$_MASTER_layout_3_time = 0;
$_MASTER_layout_4_time = 0;

echo '<br>';

/******** function to convert a 6 digit timestamp into timevalue in seconds ************/

function convertTimestampToSeconds($timestamp) {
	
	$return = (($timestamp[0].$timestamp[1]) * 3600)+(($timestamp[2].$timestamp[3]) * 60)+($timestamp[4].$timestamp[5]);

	return($return);
}


/*******  BEGIN FOR echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 1: '.$tempArrayLayoutDuration[0][1];
		echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 2: '.$tempArrayLayoutDuration[0][2];
		echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 3: '.$tempArrayLayoutDuration[0][3];
		echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 4: '.$tempArrayLayoutDuration[0][4];LOOP: EACH ITERATION IS A DOCUMENT IN THE DIR  **********/

for ( $i=2; $i<count($flashLogArray); $i++) {

	//aggregate variables for each session
	$tempViewingTDuration = 0;
	$tempViewingPDuration = 0;
	$tempViewingSlidePreviews = 0;
	$tempViewingPreDuration = 0;
	for( $j=1; $j<5; $j++ ){
		$tempArrayLayoutDuration[0][$j] = 0;
	}



// ------ report list of ips ------------------------------------//

	//Matches just the first (and only) line where the flash session reports the IP address of the user.
	//The $tempArrayIP timestamp will also be used as the start of the duration, which is
	//used in calculating other durations as well.

	//|20071011_124008.9187|#<IP_ADDRESS % 68.40.191.80>
	preg_match_all('/(\d{4})(\d{4})\_(\d{6}\.\d{4})\|#<IP_ADDRESS\s\%\s(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/',implode('',file($PATH_TO_LOG_LOCATION.$flashLogArray[$i])), $tempArrayIP);

	/* tempArrayIP:	[0][0] = 20071011_124008.9187|#<IP_ADDRESS % 68.40.191.80
			[1][0] = 2007
	  		[2][0] = 1011
			[3][0] = 124008.9187
			[4][0] = 68.40.191.80	*/

	echo '<br><br><b>IP: '.$tempArrayIP[4][0].' </b> connected at: '.$tempArrayIP[1][0].$tempArrayIP[2][0].'_'.$tempArrayIP[3][0];

	$_MASTER_IParray[$i][0] = $tempArrayIP[4][0];	//store ip
	$_MASTER_IParray[$i][1] = $tempArrayIP[3][0];	//store timestamp
	$_MASTER_IParray[$i][2] = $tempArrayIP[1][0].$tempArrayIP[2][0]; //store date 

	/* $_MASTER_IParrray:	[0][0] = 68.40.191.80
				[0][1] = 124008.9187
				[0][2] = 20071011	*/



// ------ get viewing durations for each session ---------------//

	//|20071011_124008.9187|
	preg_match_all('/\d{4}(\d{4})\_(\d{6})\.\d{4}/', implode('',file($PATH_TO_LOG_LOCATION.$flashLogArray[$i])), $tempArrayEnd);

	/* tempArrayEnd:[0][0] = 20071011_124008.9187
			[1][0] = 1011
			[2][0] = 124008		*/

	//The following if statement checks to see if the two events are timestamped on the same date.  If not,
	//a different calculation will need to be used to determine the duration.  This if statement is used
	//for every duration determination.

	if( $tempArrayIP[2][0] != $tempArrayEnd[1][count($tempArrayEnd[2])-1] ){
		$duration = ((24*3600)-convertTimeStampToSeconds($tempArrayIP[3][0]))+convertTimestampToSeconds($tempArrayEnd[2][(count($tempArrayEnd[2])-1)]);
	} else {
		$duration = ( convertTimestampToSeconds($tempArrayEnd[2][count($tempArrayEnd[2])-1]) - convertTimestampToSeconds($tempArrayIP[3][0]) );          
	}

	echo '  for: '.$duration.' seconds';

	$_MASTER_duration += $duration;	
	$_MASTER_IParray[$i][3] = $duration;  // $_MASTER_IParray[0][4] = 138




// ------ get total time seeking for each session -----------------//

	echo '<br>';

	//|20071009_203257.4989|#<LECTURE_TRANSPORT_FFP_START % 121.155>
	preg_match_all('/\d{4}(\d{4})\_(\d{6}\.\d{4})\|#<LECTURE_TRANSPORT_(\w{2})\w{0,1}_(\w{4,5})\s\%\s(\d+\.?\d{2}?)/', implode('',file($PATH_TO_LOG_LOCATION.$flashLogArray[$i])), $tempArrayTransport);

	/* tempArrayTrasnport:	[0][0] = 20071009_203257.4989|#<LECTURE_TRANSPORT_FFP_START % 121.15
				[1][0] = 1009
				[2][0] = 203257.4989
				[3][0] = FF
				[4][0] = START
				[5][0] = 121.15		*/

	//|20071011_124014.8058|#<SEEK_BAR_DRAG % 216 | 214.360650174216> \s\%\s(\d+\.?\d?)\s\|\s(\d+\.?\d?)
	preg_match_all('/\d{4}(\d{4})\_(\d{6}\.\d{4})\|#<SEEK_BAR_(\w{4})\w?\s\%\s(\d+\.?\d{2})\d*\s\|\s(\d+\.?\d{2}?)/', implode('',file($PATH_TO_LOG_LOCATION.$flashLogArray[$i])), $tempArraySeekBar);

	/* tempArraySeekBar:	[0][0] = 20071011_124014.8058|#<SEEK_BAR_DRAG % 216 | 214.36
				[1][0] = 1011
				[2][0] = 124014.8058
				[3][0] = DRAG
				[4][0] = 216
				[5][0] = 214.36		*/

	//The first for loop finds a START transport, then a STOP transport and compares their times to get a transport duration.
	//if there is no STOP for the last transport it is ignored.

	for( $j=0; $j<count($tempArrayTransport[2]); $j=$tempFirstFound+1 ){

		while( $tempArrayTransport[4][$j] != 'START' && $j < count($tempArrayTransport[2]) ){ $j++; }
		$tempTimeStart = $tempArrayTransport[2][$j];
		$tempStartType = $tempArrayTransport[3][$j];
		$tempFirstFound = $j;

		while( ($tempArrayTransport[4][$j] != 'STOP' || $tempArrayTransport[3][$j] != $tempStartType) && $j < count($tempArrayTransport[2]) ) { $j++; }

		$pDuration = abs($tempArrayTransport[5][$tempFirstFound] - $tempArrayTransport[5][$j]);
	
		if( $tempFirstFound < count($tempArrayTransport[2]) ){
			if( $tempArrayTransport[1][$tempFirstFound] != $tempArrayTransport[1][$j]) {
				$tDuration = ((24*3600)-convertTimeStampToSeconds($tempTimeStart))+convertTimestampToSeconds($tempArrayTransport[2][$j]);
			} else {
				$tDuration = (convertTimeStampToSeconds($tempArrayTransport[2][$j]) - convertTimeStampToSeconds($tempTimeStart));
			}
			
			$tempViewingTDuration += $tDuration;
			$tempViewingPDuration += $pDuration;
			$_MASTER_transportDuration += $tDuration;
			$_MASTER_playheadDuration += $pDuration;

			echo '<br>&nbsp;&nbsp;&nbsp;&nbsp;Transport type: '.$tempArrayTransport[3][$j].'  of duration: '.$tDuration.'  through '.$pDuration.' of video.';
		}
	}

	//This for loop checks for every use of the seek bar...

	for( $j=0; $j<count($tempArraySeekBar[2]); $j++ ){
		
		echo '<br>&nbsp;&nbsp;&nbsp;&nbsp;Seek bar ';
		if( $tempArraySeekBar[3][$j] == 'DRAG' ){ echo 'drag'; $_MASTER_seekBarDragNumber++; } else { echo 'click'; $_MASTER_seekBarClickNumber++; }
		echo ' from: '.$tempArraySeekBar[4][$j].' to '.$tempArraySeekBar[5][$j];
		
		$_MASTER_playheadDuration += abs( $tempArraySeekBar[5][$j] - $tempArraySeekBar[4][$j] );
		$tempViewingPDuration += abs( $tempArraySeekBar[5][$j] - $tempArraySeekBar[4][$j] );
		
	}

	echo '<br>Total viewing transport time: '.$tempViewingTDuration.' seconds transporting through '.$tempViewingPDuration.' seconds of video.<br><br>';




// ------ report slide browser usage for each session --------------//

	//|20071010_135354.5395|#<PREVIEW_START % slides/20071008110029.jpg>   
	preg_match_all('/\d{4}(\d{4})\_(\d{6}\.\d{4})\|#<PREVIEW_(\w{4,5})\s\%\sslides\/(\d*)/',implode('',file($PATH_TO_LOG_LOCATION.$flashLogArray[$i])), $tempArrayPreview);

	/* tempArrayPreview:	[0][0] = 20071010_135354.5395|#<PREVIEW_START % slides/20071008110029
				[1][0] = 1010
				[2][0] = 135354.5395
				[3][0] = START
				[4][0] = 20071008110029		*/

	//|20071010_135408.1628|#<SLIDE_CLICK % slides/20071008110358.jpg>
	preg_match_all('/\d{4}(\d{4})\_(\d{6}\.\d{4})\|#<SLIDE_CLICK\s\%\sslides\/(\d*)/',implode('',file($PATH_TO_LOG_LOCATION.$flashLogArray[$i])), $tempArrayClick);

	/* tempArrayClick:	[0][0] = 20071010_135408.1628|#<SLIDE_CLICK % slides/20071008110358
				[1][0] = 1010
				[2][0] = 135408.1628
				[4][0] = 20071008110358		*/

	//Like the for loop in the transport duration section, this loop checks for a preview START then find the accompanying
	//STOP and figures the duration inbetween.  If there is no STOP, it is ignored.
	
	for( $j=0; $j<count($tempArrayPreview[2]); $j=$tempFirstFound+1){
	
		while( $tempArrayPreview[3][$j] != 'START' && $j < count($tempArrayPreview[2]) ){ $j++; }
		$tempTimeStart = $tempArrayPreview[2][$j];
		$tempFirstFound = $j;

		while( $tempArrayPreview[3][$j] != 'STOP' && $j < count($tempArrayPreview[2]) ) { $j++; }

		if( $j < count($tempArrayPreview[2]) ){
			if( $tempArrayPreview[1][$tempFirstFound] != $tempArrayPreview[1][$j] ){
				$preDuration = ((24*3600)-convertTimeStampToSeconds($tempTimeStart))+convertTimestampToSeconds($tempArrayPreview[2][$j]);
			} else {
				$preDuration = (convertTimeStampToSeconds($tempArrayPreview[2][$j]) - convertTimeStampToSeconds($tempTimeStart));
			}

			$_MASTER_slidePreviews++;
			$tempViewingSlidePreviews++;
			
			$_MASTER_previewDuration += $preDuration;
			$tempViewingPreDuration += $preDuration;

			echo '<br>&nbsp;&nbsp;&nbsp;&nbsp;Preview of slide: '.$tempArrayPreview[4][$j].'  of duration: '.$preDuration;
		}

	}
	
	//output each click
	for( $j=0; $j<count($tempArrayClick[2]); $j++){
			echo '<br>&nbsp;&nbsp;&nbsp;&nbsp;Click on slide: '.$tempArrayClick[3][$j];
	}
	
	$_MASTER_slideClickNumber += count($tempArrayClick[2]);

	echo '<br>Total slide previews: '.$tempViewingSlidePreviews.' for '.$tempViewingPreDuration.' seconds.';
	echo '<br>Total slide clicks: '.count($tempArrayClick[2]);




// ------ report layout duration for each session --------------//

	echo '<br><br>';

	//20071012_180856.6675|#<LAYOUT_CHANGE % 3>  
	preg_match_all('/\d{4}(\d{4})\_(\d{6}\.\d{4})\|#<LAYOUT_CHANGE\s\%\s(\d{1})/',implode('',file($PATH_TO_LOG_LOCATION.$flashLogArray[$i])), $tempArrayLayout);

	/* tempArrayLayout:	[0][0] = 20071012_180856.6675|#<LAYOUT_CHANGE % 3>  
				[1][0] = 1012
				[2][0] = 180856.6675
				[3][0] = 3	*/

	//If statement checks to see that there are layout changes.  If not it will simply use the duration as layout 1's duration.

	if( count($tempArrayLayout[2]) > 0 ){

		//Primer if: since layout 1 is always first, gets the time from the start to the first change and
		//applies it to layout 1's total duration.

		if( $tempArrayLayout[1][0] != $tempArrayIP[2][0] ){
			$tempArrayLayoutDuration[0][1] += ((24*3600)-convertTimeStampToSeconds($tempArrayIP[3][0]))+convertTimestampToSeconds($tempArrayLayout[2][0]);
		} else {
			$tempArrayLayoutDuration[0][1] += (convertTimeStampToSeconds($tempArrayLayout[2][0]) - convertTimeStampToSeconds($tempArrayIP[3][0]));
		}

		echo '<br>Layout changed to '.$tempArrayLayout[3][0].' at '.$tempArrayLayout[2][0];

		//For statement finds each layout change and determines the time from the previous change to this one,
		//then applies it to the previous layout's total time. Runs through the last change.

		for( $j=1; $j<count($tempArrayLayout[2]); $j++ ){
			
			if( $tempArrayLayout[1][($j-1)] != $tempArrayLayout[1][$j] ){
				$tempArrayLayoutDuration[0][$tempArrayLayout[3][($j-1)]] += ((24*3600)-convertTimeStampToSeconds($tempArrayLayout[2][($j-1)]))+convertTimestampToSeconds($tempArrayLayout[2][$j]);
			} else {
				$tempArrayLayoutDuration[0][$tempArrayLayout[3][($j-1)]] += (convertTimeStampToSeconds($tempArrayLayout[2][$j]) - convertTimeStampToSeconds($tempArrayLayout[2][($j-1)]));
			}

			echo '<br>Layout changed to '.$tempArrayLayout[3][$j].' at '.$tempArrayLayout[2][$j];
		}

		//determine time from last change to end of viewing and apply it to the last layout
		$tempArrayLayoutDuration[0][$j] += $duration-$tempArrayLayoutDuration[0][1]-$tempArrayLayoutDuration[0][2]-$tempArrayLayoutDuration[0][3]-$tempArrayLayoutDuration[0][4];

		echo '<br>Total layout time for each layout:';
		echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 1: '.$tempArrayLayoutDuration[0][1];
		echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 2: '.$tempArrayLayoutDuration[0][2];
		echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 3: '.$tempArrayLayoutDuration[0][3];
		echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 4: '.$tempArrayLayoutDuration[0][4];

		$_MASTER_layout_1_time += $tempArrayLayoutDuration[0][1];
		$_MASTER_layout_2_time += $tempArrayLayoutDuration[0][2];
		$_MASTER_layout_3_time += $tempArrayLayoutDuration[0][3];
		$_MASTER_layout_4_time += $tempArrayLayoutDuration[0][4];
	
	} else {
		
		$_MASTER_layout_1_time += $duration;
		echo '<br><br>No layout changes.  Layout 1 duration: '.$duration;
	}

echo '<br><br><br>';

}


//output the _MASTER variables:
echo '<br><br><br><br><b>----------------------------------------------TOTALS:<br>';
echo 'total viewing duration: '.$_MASTER_duration;
echo '<br>total transport duration: '.$_MASTER_transportDuration;
echo '<br>total transported video time: '.$_MASTER_playheadDuration;
echo '<br>total preview time: '.$_MASTER_previewDuration;
echo '<br>number of slide clicks: '.$_MASTER_slideClickNumber;
echo '<br>number of seek bar clicks: '.$_MASTER_seekBarClickNumber;
echo '<br>number of seek bar drags: '.$_MASTER_seekBarDragNumber;
echo '<br>usage by layout:';
	echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 1: '.$_MASTER_layout_1_time;
	echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 2: '.$_MASTER_layout_2_time;
	echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 3: '.$_MASTER_layout_3_time;
	echo '<br>&nbsp;&nbsp;&nbsp;&nbsp; 4: '.$_MASTER_layout_4_time;

echo '<br><br>usage by IP:<br></b>';

for( $i=2; $i<count($flashLogArray); $i++ ){
	echo '<br><b>'.$_MASTER_IParray[$i][0].'</b> on '.$_MASTER_IParray[$i][2].' at '.$_MASTER_IParray[$i][1].' for <b>'.$_MASTER_IParray[$i][3].'</b> seconds.';
}

echo "</b><br><br>hello world."; 


?>
