<?php
// ====================================================================
// Copyright (c) 2010 The Regents of the University of Michigan and 
// The European Organization for Nuclear Research (CERN). Licensed under the
// Educational Community License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License. You may
// obtain a copy of the License at
//
// http://www.osedu.org/licenses/ECL-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an "AS IS"
// BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing
// permissions and limitations under the License.
// ====================================================================

/********************************************************************************
 *										*
 *  PHP flash logging script.  Receives a call from action script posting two	*
 *  variables, 'timestamp' and 'logData.'  The timestamp variable is determined *
 *  at first run by the .swf and acts as a session ID, and so will always be 	*
 *  the same for any given session.  The logData will contain a tag encoded	*
 *  ( <> ) set of data pertaining to an event in the flash.  This script takes	*
 *  that data, timestamps it (from server time) with YYYYMMDD_HHmmss.uuuu	*
 *  and appends it to a file that is named with the session ID and is located	*
 *  in the log location sepecified in this script.				*
 *										*
 *  Curtis Hiller / 2007-10-01							*
 *										*
 ********************************************************************************/


//path to the place where the logs are stored
$PATH_TO_LOG_LOCATION = 'flashLogs/';

//formatting markers
$TIMESTAMP_MARKER = '|';
$CONNECTION_MARKER = '#';
$NEWLINE = "\n";


//generate local timestamp 
$timestamp = $TIMESTAMP_MARKER.date('Ymd_His.');

$uTime = microtime(); //work around for old PHP that doesn't have microseconds in data()
for($i=2;$i<6;$i++) { $timestamp .= $uTime[$i]; }
$timestamp .= $TIMESTAMP_MARKER;

//echo $timestamp;


//----------------------------------------------------

//import timestamp (session ID) from flash "post"
$fileNameStringFromFlash = $_POST['timestamp'];

//import the data from flash "post"
$dataFromFlash = $_POST['logData'];

//if it's the first post from a session, which will be an IP request, get the IP and print that
if ( $dataFromFlash == '<IP_ADDRESS_REQUEST>' ) {
	$dataFromFlash = '<IP_ADDRESS % '.$_SERVER['REMOTE_ADDR'].'>';
}

//----------------------------------------------------


//open the file for appending
$textFileHandler = fopen($PATH_TO_LOG_LOCATION.$fileNameStringFromFlash.'.txt','a');

//write to file
fwrite($textFileHandler, $NEWLINE.$timestamp.$CONNECTION_MARKER.$dataFromFlash);

//return local timestamp to flash (for test purposes)
//print("&timestamper=$timestamp");

fclose($textFileHandler);


?>
