# ====================================================================
# Copyright (c) 2010 The Regents of the University of Michigan and 
# The European Organization for Nuclear Research (CERN). Licensed under the
# Educational Community License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may
# obtain a copy of the License at
#
# http://www.osedu.org/licenses/ECL-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS"
# BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing
# permissions and limitations under the License.
# ====================================================================

############################################################
# settings2perl.py
#
# Author: Jeremy Herr (herrj@umich.edu)
#
# This script translates the Python conf file (conf.py)
# to a Perl version. So the only file that is edited should
# be the Python file. When done editing, run settings2perl.py
# so the Perl scripts will run ok.
#
############################################################

import os
import conf

str_file_py = os.path.join(conf.micalaHome, "micala", "etc", "conf.py")
str_file_pl = os.path.join(conf.micalaHome, "micala", "etc", "processing.conf")

file_py = open(str_file_py, "r")
file_pl = open(str_file_pl, "w")

lines = file_py.readlines()
for line in lines:
    # remove spaces from beginning and end
    line_edit = line.strip()

    # Get rid of any trailing comments
    line_edit = line_edit.partition("#")[0]

    # remove spaces from beginning and end again
    line_edit = line_edit.strip()

    # ignore comments and blank lines
    if len(line_edit) > 0 and line_edit[0] != "#":
        # add $ to beginning, ; to end of line
        line_edit = "$" + line_edit + ";" + "\n"
        # write line to output file
        file_pl.write(line_edit)

file_py.close()
file_pl.close()
