# ====================================================================
# Copyright (c) 2010 The Regents of the University of Michigan and
# The European Organization for Nuclear Research (CERN). Licensed under the
# Educational Community License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may
# obtain a copy of the License at
#
# http://www.osedu.org/licenses/ECL-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS"
# BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing
# permissions and limitations under the License.
# ====================================================================

import conf
import MicalaTemplate as mt

class MicalaController(object):
    "BaseController Class"
    _templatePage = ""
    _pageVars = None
    def process(self, params):
        # set to false, web app doesn't show debug messages on the pages
        conf.consoleDisplay = False
        # call the process method in the child class
        self._process(params)
        # create a new template for this controller
        page = mt.MicalaTemplate(self.templatePage)
        # render the template
        page.render(self.pageVars)