# ====================================================================
# Copyright (c) 2010 The Regents of the University of Michigan and
# The European Organization for Nuclear Research (CERN). Licensed under the
# Educational Community License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may
# obtain a copy of the License at
#
# http://www.osedu.org/licenses/ECL-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS"
# BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing
# permissions and limitations under the License.
# ====================================================================

from MicalaController import *
from micala import MicalaCommunication

import conf

class MicalaLectureDeleteController(MicalaController):
    "Delete a lecture passed as parameter"
    # template file for lecture details controller: in this case will be redirect to admin home page
    templatePage = ""
    # dictionary to pass to the template
    pageVars = None

    @classmethod
    def _deleteLecture(self, idLecture):
        "Delete the lecture object from the database"
        MicalaCommunication.deleteLectureRecord(idLecture)

    @classmethod
    def _process(self, params):
        "Dispatcher action"

        if params is not None:
            if params.has_key('idLecture'):
                idLecture = params['idLecture'].value
                if idLecture.isdigit():
                    # delete lecture object
                    self._deleteLecture(idLecture)
                    # redirect to home page
                    print "Location: http://" + conf.curr_machine + "/monitor/monitor.py"
