# ====================================================================
# Copyright (c) 2010 The Regents of the University of Michigan and
# The European Organization for Nuclear Research (CERN). Licensed under the
# Educational Community License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may
# obtain a copy of the License at
#
# http://www.osedu.org/licenses/ECL-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS"
# BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing
# permissions and limitations under the License.
# ====================================================================

from MicalaController import *
from micala import *

import re

class MicalaLecturePreviewsController(MicalaController):
    "Lecture Previews Controller to show the GIF preview"
    # template file for monitor preview controller
    templatePage = "lecturePreviews"
    # dictionary to pass to the template
    pageVars = None

    @classmethod
    def _process(self, params):
        "Dispatcher action"
        # initialize a dictionary for the variables to pass to the template
        self.pageVars = dict()
        # default values for variables
        self.pageVars['showMethod'] = 'Portrait'
        self.pageVars['LOID'] = None
        self.pageVars['previewComplete'] = False

        if params is not None and params.has_key("idLecture"):
            # get the latest status for Building Preview
            if params["idLecture"].value.isdigit() and params.has_key("LOID") and params.has_key("showMethod"):
                self.pageVars['LOID'] = params["LOID"].value
                self.pageVars['showMethod'] = params["showMethod"].value
                latestStatus = MicalaCommunication.getLatestStatus(params["idLecture"].value, "building preview")
                if latestStatus is not None and latestStatus.has_key("Status") and latestStatus["Status"] == "COMPLETE":
                    self.pageVars['previewComplete'] = True


