# ====================================================================
# Copyright (c) 2010 The Regents of the University of Michigan and
# The European Organization for Nuclear Research (CERN). Licensed under the
# Educational Community License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may
# obtain a copy of the License at
#
# http://www.osedu.org/licenses/ECL-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS"
# BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing
# permissions and limitations under the License.
# ====================================================================

from MicalaController import *
from micala import MicalaCommunication

class MicalaTasksUpdateOrderingController(MicalaController):
    "Update tasks ordering controller"
    # template file for tasks controller
    templatePage = "tasksUpdateOrdering"
    # dictionary to pass to the template
    pageVars = None

    @classmethod
    def _process(self, params):
        "Dispatcher action"
        # initialize a dictionary for the variables to pass to the template
        self.pageVars = dict()
        self.pageVars["message"] = ''

        if params is not None:
            # check params
            if params.has_key('action') and params['action'].value == 'updateTasksOrdering':
                i = 1
                # for each task, edit its order value, progressive value: 1,2,3...
                for task in params['task[]']:
                    MicalaCommunication.updateTaskOrder(task.value, i)
                    i+=1
                self.pageVars["message"] = 'Order saved'
