# ====================================================================
# Copyright (c) 2010 The Regents of the University of Michigan and
# The European Organization for Nuclear Research (CERN). Licensed under the
# Educational Community License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may
# obtain a copy of the License at
#
# http://www.osedu.org/licenses/ECL-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS"
# BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing
# permissions and limitations under the License.
# ====================================================================

import conf

#import Mako Template System
from mako.template import Template
from mako.lookup import TemplateLookup
from mako import exceptions

class MicalaTemplate(object):
    "Class to render a page template"
    lookupTemplate = None
    fileTemplate = None
    def __init__(self, page):
        self.lookupTemplate = TemplateLookup(directories=['templates/' + conf.currentTemplate])
        #Template page has the same name, but different extension
        self.fileTemplate = self.lookupTemplate.get_template(page + '.mako')
    def render(self, pageVars):
        # header (the newline is necessary to end the header)
        print 'Content-type: text/html'
        print
        try:
            # render the template, passing variables
            print self.fileTemplate.render(**pageVars)
        except:
            print exceptions.html_error_template().render()