# ====================================================================
# Copyright (c) 2010 The Regents of the University of Michigan and
# The European Organization for Nuclear Research (CERN). Licensed under the
# Educational Community License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may
# obtain a copy of the License at
#
# http://www.osedu.org/licenses/ECL-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS"
# BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing
# permissions and limitations under the License.
# ====================================================================

from MicalaController import *
from micala import MicalaCommunication

class MicalaVenueDetailsController(MicalaController):
    "Detail Venue Controller to get all details of a venue"
    # template file for venue details controller
    templatePage = "venueDetails"
    # dictionary to pass to the template
    pageVars = None

    @classmethod
    def _getVenue(self, idVenue):
        "Get a venue"
        if idVenue == '0':
            # New venue
            venue = dict()
            venue["idVenue"] = '0'
            venue["RoomName"] = ''
            venue["IndicoRoomID"] = ''
        else:
            # Edit venue
            venue = MicalaCommunication.getVenue(idVenue)

        self.pageVars['venue'] = venue

    @classmethod
    def _process(self, params):
        "Dispatcher action"
        # initialize a dictionary for the variables to pass to the template
        self.pageVars = dict()

        # check parameters
        if params is not None and params.has_key("action") :
            if params["action"].value == "getVenue" and params["idVenue"].value.isdigit():
                self._getVenue(params["idVenue"].value)

