// ====================================================================
// Copyright (c) 2010 The Regents of the University of Michigan and
// The European Organization for Nuclear Research (CERN). Licensed under the
// Educational Community License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License. You may
// obtain a copy of the License at
//
// http://www.osedu.org/licenses/ECL-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an "AS IS"
// BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing
// permissions and limitations under the License.
// ====================================================================

// Show machine form of the selected machine
function machineShowForm(idMachine){
	$(document).ready(function(){
		$('#loading').show();
		$.post('machineDetails.py',
				'action=getMachine&idMachine=' + idMachine,
				function(machineDetails){
					$('#loading').hide();
					// Show the response: details of the machine
					$("#machineDetails").html(machineDetails);
					// create the submit button
					$("#btnSubmit").button();
					// submit button click event
					$("#btnSubmit").click(function(){
						// submit edit/insert machine
						if (checkForm())
							submitFormMachines();
						return false;
				    });
				}
		);
	});
}

// Show a confirm box when submitting using jQuery UI
function submitFormMachines(){
	$("#confirmBox").dialog({
		resizable: true,
		height: 200,
		width: 300,
		modal: true,
		buttons: {
			"Submit changes": function() {
				$(this).dialog("close");
				// Ok button pressed, submit the form
				$("#submitFormMachines").submit();
			},
			Cancel: function() {
				$(this).dialog("close");
			}
		}
	});
}

// Check input form
function checkForm(){
	if ( isNaN($('#Memory').val()) || isNaN($('#Disk').val()) ){
		$("#errorBox").dialog({
			resizable: true,
			height: 150,
			modal: true,
			buttons: {
				"Ok": function() {
					$(this).dialog("close");
				}
			}
		});
		return false;
	} else
		return true;
}