// ====================================================================
// Copyright (c) 2010 The Regents of the University of Michigan and
// The European Organization for Nuclear Research (CERN). Licensed under the
// Educational Community License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License. You may
// obtain a copy of the License at
//
// http://www.osedu.org/licenses/ECL-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an "AS IS"
// BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing
// permissions and limitations under the License.
// ====================================================================

// On document load, execute this
$(document).ready(function(){
	$('#radioFilterContentType').buttonset().click(function(){
		updateMonitorList();
		return false;
	});
	$('#radioFilterOrphanStatus').buttonset().click(function(){
		updateMonitorList();
		return false;
	});
	$('#radioFilterFinished').buttonset().click(function(){
		updateMonitorList();
		return false;
	});

	$('#btnFilterAgeLecture').button().click(function(){
		if ($('#filterAgeLectureOld').val() != $('#filterAgeLecture').val()){
			$('#filterAgeLectureOld').val($('#filterAgeLecture').val());
			updateMonitorList();
			return false;
		}
	});
	// Show all LO
	updateMonitorList();
});

// Set the button pressed as checked
function setChecked(btn){
	$(btn).attr('checked', 'checked');
}

// update monitoring list with sortBy and sortOrder default values
function updateMonitorList(){
	updateMonitorListSorted('DateCreated', 'DESC');
	return false;
}
// Update the list with filters and sorting the LO list
function updateMonitorListSorted(sortBy, sortOrder){
	filters = 'filterAgeLecture=' + $('#filterAgeLecture').val();

	if ($('#radioFilterContentType :radio:checked').val() == null) filterValue = '-1'; else filterValue = $('#radioFilterContentType :radio:checked').val();
	filters += '&filterContentType=' + filterValue;

	if ($('#radioFilterOrphanStatus :radio:checked').val() == null) filterValue = '-1'; else filterValue = $('#radioFilterOrphanStatus :radio:checked').val();
	filters += '&filterOrphanStatus=' + filterValue;

	if ($('#radioFilterFinished :radio:checked').val() == null) filterValue = '-1'; else filterValue = $('#radioFilterFinished :radio:checked').val();
	filters += '&filterFinished=' + filterValue;

	filters += '&sortBy=' + sortBy;
	filters += '&sortOrder=' + sortOrder;

	$('#monitorList').html('');
	$('#loadingMonitorList').css('margin','50px');
	$('#loadingMonitorList').show();
	$.post('monitorList.py',
			filters,
			function(response){
				$('#loadingMonitorList').hide();
				$('#monitorList').html(response);
				$('#showNumLectures').html($('#numLectures').val());
			}
	);
	return false;
}

// Show/Hide lecture details
function toggleDetails(idLecture, LOID){
	if($('#lecture_' + idLecture).is(":visible")){
		// Hide
		$('#tr_lecture_' + idLecture).removeClass('selected');
		$('#td_lecture_' + idLecture).removeClass('hideDetails');
		$('#lecturePreviews_' + idLecture).html('');
		$('#lecture_' + idLecture).slideUp();
		// Clear task status list
		$('#td_lecture_' + idLecture).addClass('showDetails');
	} else {
		// Show
		showLecturePreview(idLecture, LOID);
		$('#td_lecture_' + idLecture).removeClass('showDetails');
		$('#lecture_' + idLecture).slideDown(function(){
			$('html,body').animate({
		         scrollTop: $('#lecture_' + idLecture).offset().top - 200
		    });
		});
		$('#td_lecture_' + idLecture).addClass('hideDetails');
		$('#tr_lecture_' + idLecture).addClass('selected');
	}
	return false;
}

// Show previews
function showLecturePreview(idLecture, LOID){
	$.post('monitorPreview.py',
			'idLecture=' + idLecture + '&LOID=' + LOID + '&showMethod=Portrait',
			function(response){
				$('#lecturePreviews_' + idLecture).html(response);
			}
	);
}