// ====================================================================
// Copyright (c) 2010 The Regents of the University of Michigan and
// The European Organization for Nuclear Research (CERN). Licensed under the
// Educational Community License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License. You may
// obtain a copy of the License at
//
// http://www.osedu.org/licenses/ECL-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an "AS IS"
// BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing
// permissions and limitations under the License.
// ====================================================================

// On document load, execute this
$(document).ready(function(){
	// When the list of task become sortable, and a task is drag-and-dropped
	$("#listTasks").sortable(
			{opacity: 0.6,
			cursor: 'pointer',
			placeholder: "ui-state-highlight",
			update: function(){
				// serialize all tasks
				var order = $(this).sortable("serialize") + '&action=updateTasksOrdering';
				$('#loading').show();
				// send request to save the order
				$.post("tasksUpdateOrdering.py",
						order,
						function(orderingResponse){
							$('#loading').hide();
							// show the response
							$("#resultOrdering").html(orderingResponse);
							$("#resultOrdering").fadeIn().delay(2000).fadeOut();
						}
				);
			}
			});
	// create the submit button for new task
	$("#newTaskSubmit").button({ disabled: true });
});

// Enable/disable tasks sorting when the link is pressed
function sortingGrant(){
	// Get the status of the list
	var sortDisabled = $("#listTasks").sortable( "option", "disabled" );
	if (sortDisabled){
		// Disabled, so enable sorting. Ask confirm, usign jQuery UI
		$("#confirmBox").dialog({
			resizable: true,
			height: 200,
			width: 300,
			modal: true,
			buttons: {
				"Enable tasks ordering": function() {
					$(this).dialog("close");
					// enable
					$("#listTasks").sortable({ disabled: false });
					// change style
					$("#listTasks li").removeClass('sortDisabled').addClass('sortEnabled');
				},
				Cancel: function() {
					$(this).dialog("close");
				}
			}
		});
	} else {
		// enabled, so disable sorting
		$("#listTasks").sortable({ disabled: true });
		// change style
		$("#listTasks li").removeClass('sortEnabled').addClass('sortDisabled');
	}
}

// Change style and disable/enable button
function taskNameInput(){
	if ($('#newTaskName').val() == 'Task name'){
		$('#newTaskName').val('');
		$('#newTaskName').css('font-style','normal');
	}
	if ($('#newTaskName').val().trim().length > 0){
		$('#newTaskSubmit').button({ disabled: false });
	} else
		$('#newTaskSubmit').button({ disabled: true });
}

// Edit inline for the task name
function taskNameShowEdit(idTask, currentTaskName){
	$('#taskName_' + idTask).html('<form action="tasks.py" method="POST" id="formEditTaskName_' +idTask +'"><input type="text" name="changedTaskName" value="' + currentTaskName + '" size="30" /> <input type="submit" id="editTaskSubmit_' +idTask +'" name="btnSubmit" value="Submit" /><input type="hidden" name="idTask" value="' + idTask + '" /><input type="hidden" name="action" value="editTaskName" /></form>');
	// create the submit button for edit task name
	$("#editTaskSubmit_" + idTask).button();
	// If edit task name button clicke, ask confirm
	$("#editTaskSubmit_" + idTask).click(function() {
		editTaskName(idTask);
		return false;
    });
}

//Show a confirm box dialog for editing task name using jQuery UI
function editTaskName(idTask){
	$("#editTaskNameBox").dialog({
		resizable: true,
		height: 200,
		width: 400,
		modal: true,
		buttons: {
			"Update name": function() {
				$(this).dialog("close");
				// edit task name
				$("#formEditTaskName_"+idTask).submit();
			},
			Cancel: function() {
				$(this).dialog("close");
				location.reload(true);
			}
		}
	});
}
