<%doc> ====================================================================
  Copyright (c) 2010 The Regents of the University of Michigan and
  The European Organization for Nuclear Research (CERN). Licensed under the
  Educational Community License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may
  obtain a copy of the License at

  http://www.osedu.org/licenses/ECL-2.0

  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an "AS IS"
  BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
  or implied. See the License for the specific language governing
  permissions and limitations under the License.
  ==================================================================== </%doc>
<%
from micala import Common
%>
<%inherit file="/baseAdmin.mako" />
<%def name="title_tag()">
	<title>Micala - Restricted Area - Lecture Details</title>
</%def>
<%def name="js_import()">
    <script src="/js/lectureDetails.js" type="text/javascript"></script>
    <script src="/js/lectureToDo.js" type="text/javascript"></script>
</%def>
<%def name="title_page()">
    <table width="100%" cellpadding="0" cellspacing="0">
        <tr>
            <td>
                ${lecture["Title"]}
                <div class="description">${lecture["DateCreated"]} - ${lecture["Creator"]}</div>
            </td>
            <td width="2%">&nbsp;</td>
	        <td valign="bottom">
               <div class="description">Lecture Object ID #${lectureObjectID}&nbsp;&nbsp;&nbsp; - &nbsp;&nbsp;&nbsp;Lecture #${idLecture}</div>
            </td>
        </tr>
    </table>
</%def>
% if error != '' and lecture is not None:
    <table width="100%">
        <tr>
            <td width="410" valign="top">
                <div class="lectureDetailsTitle"><img src="/images/lectureInfo.png" alt="Lecture Details" title="Lecture Details" style="vertical-align: middle; margin-right: 5px;" /> Lecture details</div>
                <%
                if not lecture.has_key("idLecture") or lecture["idLecture"] is None:
                    lecture["idLecture"] = ''
                if not lecture.has_key("LOID") or lecture["LOID"] is None:
                    lecture["LOID"] = ''
                if not lecture.has_key("IndicoID") or lecture["IndicoID"] is None:
                    lecture["IndicoID"] = ''
                if not lecture.has_key("CDSRecord") or lecture["CDSRecord"] is None:
                    lecture["CDSRecord"] = ''
                if not lecture.has_key("Title") or lecture["Title"] is None:
                    lecture["Title"] = ''
                if not lecture.has_key("Creator") or lecture["Creator"] is None:
                    lecture["Creator"] = ''
                if not lecture.has_key("DateCreated") or lecture["DateCreated"] is None:
                    lecture["DateCreated"] = ''
                if not lecture.has_key("DateCreated") or lecture["DateCreated"] is None:
                    lecture["DateCreated"] = ''
                if not lecture.has_key("Duration") or lecture["Duration"] is None:
                    lecture["Duration"] = ''
                else:
                    lecture["Duration"] = Common.formatDuration(lecture["Duration"])
                if not lecture.has_key("CropBegin") or lecture["CropBegin"] is None:
                    lecture["CropBegin"] = ''
                if not lecture.has_key("CropEnd") or lecture["CropEnd"] is None:
                    lecture["CropEnd"] = ''
                if not lecture.has_key("OriginPath") or lecture["OriginPath"] is None:
                    lecture["OriginPath"] = ''
                %>
                <table width="98%" align="center" cellpadding="5" cellspacing="1" class="lectureDetails">
                    <tr>
                        <td class="lectureDetailHeader" width="35%">Lecture ID</td>
                        <td class="lectureDetailRow">${lecture["idLecture"]}</td>
                    </tr>
                    <tr>
                        <td class="lectureDetailHeader">Lecture Object ID</td>
                        <td class="lectureDetailRow">${lecture["LOID"]}</td>
                    </tr>
                    <tr>
                        <td class="lectureDetailHeader">Indico ID</td>
                        <td class="lectureDetailRow">
                            ${lecture["IndicoID"]}
                            % if lectureConferenceID != '':
                            <div>
                            <a href="http://indico.cern.ch/conferenceDisplay.py?confId=${lectureConferenceID}" target="_blank">View on Indico</a><br />
                            <a href="https://indico.cern.ch/confModifCollaboration.py?tab=Recording+Manager&confId=${lectureConferenceID}" target="_blank">Recording Manager</a>
                            </div>
                            % endif
                        </td>
                    </tr>
                    <tr>
                        <td class="lectureDetailHeader">CDS Record</td>
                        <td>
                            ${lecture["CDSRecord"]}
                            % if lecture["CDSRecord"] != '':
                            <div>
                            <a href="http://cdsweb.cern.ch/record/${lecture["CDSRecord"]}" target="_blank">CERN Document Server</a>
                            </div>
                            % endif
                        </td>
                    </tr>
                    <tr>
                        <td class="lectureDetailSpace"></td>
                        <td class="lectureDetailSpace"></td>
                    </tr>
                    <tr>
                        <td class="lectureDetailHeader">Recording room</td>
                        <td class="lectureDetailRow">${lectureRoom}</td>
                    </tr>
                    <tr>
                        <td class="lectureDetailHeader">Recording machine</td>
                        <td class="lectureDetailRow">${lectureMachine}</td>
                    </tr>
                    <tr>
                        <td class="lectureDetailHeader">Duration</td>
                        <td class="lectureDetailRow">${lecture["Duration"]}</td>
                    </tr>
                    <tr>
                        <td class="lectureDetailHeader">Crop Begin</td>
                        <td class="lectureDetailRow">${lecture["CropBegin"]}</td>
                    </tr>
                    <tr>
                        <td class="lectureDetailHeader">Crop End</td>
                        <td class="lectureDetailRow">${lecture["CropEnd"]}</td>
                    </tr>
                    <tr>
                        <td class="lectureDetailHeader">Origin Files
                        % if lecture["OriginPath"] != '':
                        <div>
                        <button id="copyOriginPath">Copy URL</button>
                        </div>
                        % endif
                        </td>
                        <td><span id="originPath">${lecture["OriginPath"]}</span></td>
                    </tr>
                </table>
                <div id="lecturePreviews_${lecture["idLecture"]}" align="center"></div>
            </td>
            <td class="border">&nbsp;</td>
            <td valign="top">
                <div class="lectureDetailsTitle"><img src="/images/lectureTasksStatus.png" alt="Status of each task for this lecture" title="Status of each task for this lecture" style="vertical-align: middle; margin-right: 5px;" /> Tasks Status</div>
                <div id="loadingTasksStatus" style="display: none;"><img src="/images/loadingBig.gif" alt="loading" title="loading" /></div>
                <div id="tasksStatus"></div>
            </td>
            <td class="border">&nbsp;</td>
            <td width="29%" valign="top">
                <div class="lectureDetailsTitle"><img src="/images/todoList.png" alt="To-do list" title="To-do list" style="vertical-align: middle; margin-right: 5px;" /> Check-list for operators</div>
                <div id="loadingToDoList" style="display: none;"><img src="/images/loadingBig.gif" alt="loading" title="loading" /></div>
                <div id="toDoList"></div>
                <form>
                <table class="crop" cellpadding="0" cellspacing="0" width="98%">
                    <tr class="section">
                        <td>CROP Tools</td>
                    </tr>
                    <tr class="content">
                        <td>
                            <table align="center" cellpadding="0" cellspacing="0">
                                <tr>
                                    <td><img src="/images/movieStart.png" title="movieStart" alt="movieStart" style="vertical-align: middle; margin-right: 5px;" /> Crop START</td>
                                    <td><input type="text" id="cropStartTime" name="cropStartTime" value="hh:mm:ss" size="8" class="italic" onClick="changeStyle('#cropStartTime');" onKeyPressed="changeStyle('#cropStartTime);" onBlur="checkTimeFormat('#cropStartTime');" /></td>
                                </tr>
                                <tr>
                                    <td><img src="/images/movieEnd.png" title="movieEnd" alt="movieEnd" style="vertical-align: middle; margin-right: 5px;" /> Crop END</td>
                                    <td><input type="text" id="cropEndTime" name="cropEndTime" value="hh:mm:ss" size="8" class="italic" onClick="changeStyle('#cropEndTime');" onKeyPressed="changeStyle('#cropEndTime);" onBlur="checkTimeFormat('#cropEndTime');" /></td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr class="section">
                        <td>Processing</td>
                    </tr>
                    <tr class="content">
                        <td>
                            <div style="margin: 4px;">Convert raw f4v files, analyze slides, create Lecture Object</div>
                            <div align="center">
                                <button id="bntStartProcessing">Start processing</button>
                            </div>
                        </td>
                    </tr>
                </table>
                <input type="hidden" name="idLecture" id="idLecture" value="${idLecture}" />
                <input type="hidden" name="LOID" id="LOID" value="${lecture["LOID"]}" />
                </form>
            </td>
        </tr>
    </table>
    <br />
    <div class="lectureDetailsTitle"><img src="/images/lectureLog.png" alt="Log list" title="Log list" style="vertical-align: middle; margin-right: 5px;" /> Log</div>
    <div id="loadingLogList" style="display: none;"><img src="/images/loadingBig.gif" alt="loading" title="loading" /></div>
    <div id="logList"></div>
    <br />
    <form action="lectureDelete.py" method="post" id="deleteLO">
    <div class="lectureDelete">
        <button id="btnDeleteLO">Delete LectureObject</button><input type="hidden" name="idLecture" value="${idLecture}" />
    </div>
    </form>
    <div id="confirmBox" title="Start processing" class="infoBox">
    Are you sure you want to start the process?
    </div>
    <div id="processingResponse" title="Processing request status" class="infoBox"></div>
    <div id="errorBoxFormat" title="Time format error" class="errorBox">
    Time format inserted is not correct.<br />Insert the time value with the format <i>hh:mm:ss</i><br /> and correct values or leave it blank.
    </div>
    <div id="errorBoxEndBeforeStart" title="Time error" class="errorBox">
    Start time inserted is after End time inserted. Check the values.
    </div>
    <div id="errorWorksOnlyIE" title="Browser error" class="errorBox">
    Copy to clipboard function works only with Internet Explorer
    </div>
    <div id="deleteBox" title="Delete the lecture object" class="errorBox">
    Are you sure you want to delete this Lecture Object?
    <div align="center"><b>IMPORTANT</b></div>
    Warning: This action will completely purge all metadata and status updates for this lecture from the database. This action can not be undone.
    </div>
% else:
<div class="noEntries">${error}</div>
% endif