<%doc> ====================================================================
  Copyright (c) 2010 The Regents of the University of Michigan and
  The European Organization for Nuclear Research (CERN). Licensed under the
  Educational Community License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may
  obtain a copy of the License at
 
  http://www.osedu.org/licenses/ECL-2.0
 
  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an "AS IS"
  BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
  or implied. See the License for the specific language governing
  permissions and limitations under the License.
  ==================================================================== </%doc>
<%
from micala import Common
%>
% if listTasks:
    <table width="98%" cellpadding="0" cellspacing="1" class="lectureTasksStatus">
        <tr class="lectureTasksStatusHeader">
            <td width="36%">Task name</td>
            <td>Status</td>
            <td>Age</td>
            <td>Duration</td>
        </tr>
    % for task in listTasks:
        <tr>
            <td class="lectureTasksStatusName">${task["Name"]}</td>
            <%
            status=''
            content=''
            time=''
            duration=''
            if dictLectureLatestStatus[task["Name"]]["status"] == "START":
                if task["Name"] == "metadata export to CDS":
                    status='Pending'
                    content='PENDING'
                else:
                    status='Started'
                    content='IN PROGRESS'
                time=Common.formatTaskAge(dictLectureLatestStatus[task["Name"]]["started"])
            elif dictLectureLatestStatus[task["Name"]]["status"] == "RUNNING":
                status='Started'
                content='IN PROGRESS'
                time=Common.formatTaskAge(dictLectureLatestStatus[task["Name"]]["started"])
                if dictLectureLatestStatus[task["Name"]]["message"] != "":
                    time+=', '+dictLectureLatestStatus[task["Name"]]["message"]
            elif dictLectureLatestStatus[task["Name"]]["status"] == "COMPLETE":
                status='Complete'
                content='DONE'
            elif dictLectureLatestStatus[task["Name"]]["status"] == "ERROR":
                status='Error'
                content='ERROR '+dictLectureLatestStatus[task["Name"]]["message"]
            elif dictLectureLatestStatus[task["Name"]]["status"] == "REQUESTED":
                status='Requested'
                content='REQUESTED'
            if dictLectureLatestStatus[task["Name"]]["status"] == "COMPLETE" and dictLectureLatestStatus[task["Name"]].has_key("duration") and dictLectureLatestStatus[task["Name"]]["duration"] != "":
                duration=Common.formatDuration(dictLectureLatestStatus[task["Name"]]["duration"])
            %>
            <td class="task${status}">${content}</td>
            <td class="task${status}" align="center" width="10%"><span class="taskSmall">${time}</span></td>
            <td class="task${status}" align="center" width="10%"><span class="taskSmall">${duration}</span></td>
        </tr>
    % endfor
    </table>
% else:
<div class="noEntries">No tasks still inserted. Insert a new task.</div>
% endif