<%doc> ====================================================================
  Copyright (c) 2010 The Regents of the University of Michigan and
  The European Organization for Nuclear Research (CERN). Licensed under the
  Educational Community License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may
  obtain a copy of the License at
 
  http://www.osedu.org/licenses/ECL-2.0
 
  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an "AS IS"
  BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
  or implied. See the License for the specific language governing
  permissions and limitations under the License.
  ==================================================================== </%doc>
<%inherit file="/baseAdmin.mako" />
<%def name="title_tag()">
	<title>Micala - Restricted Area - Machines</title>
</%def>
<%def name="js_import()">
	<script src="/js/machine.js" type="text/javascript"></script>
</%def>
<%def name="title_page()">
	Machines
</%def>
<table>
	<tr>
		<td width="400" valign="top">
			<div class="pageSubTitle"><img src="/images/machineList.png" alt="Machine list" title="Machine list" style="vertical-align: middle; margin-right: 5px;" />Machines List</div>
			<div>
				<div class="machineNew"><img src="/images/newMachine.png" alt="New machine" title="New machine" style="vertical-align: middle;" /> <a href="#" onClick="machineShowForm('0');return false;" />New machine</a></div>
				<div class="machineList">
				% if listMachines:
				<table width="98%" cellspacing="0" cellpadding="2" class="machineList">
					<tr class="machineListHeader">
						<td>Hostname</td>
						<td align="center">IP</td>
						<td></td>
					</tr>
				<% i=0 %>
				% for machine in listMachines:
				<%
				    if machine["Hostname"] is None:
				        machine["Hostname"] = ''
				    if machine["IP"] is None:
                        machine["IP"] = ''
				%>
					<tr class="machineListRow${i}" onClick="machineShowForm('${machine["idMachine"]}');">
						<td>${machine["Hostname"]}</td>
						<td align="center">${machine["IP"]}</td>
						<td align="center"><a href="#" onClick="machineShowForm('${machine["idMachine"]}');return false;" /><img src="/images/editIcon.png" alt="Edit" title="Edit" style="vertical-align: middle; border:0;" /></a></li>
					</tr>
				<%
					i+=1
					i=i%2
				%>
				% endfor
				</table>
				% else:
				<div class="noEntries">No machines still inserted. Insert a new machine.</div>
				% endif
				</div>
			</div>
		</td>
		<td class="border">&nbsp;</td>
		<td valign="top">
			<div class="pageSubTitle"><img src="/images/machineDetails.png" alt="Machine details" title="Machine details" style="vertical-align: middle; margin-right: 5px;" />Machine details</div>
			<div id="machineDetails">
				<div class="machineDetailsInfo">Select a machine to view/edit details.<br />Click on 'New machine' to insert a new machine</div>
			</div>
		</td>
	</tr>
</table>