<%doc> ====================================================================
  Copyright (c) 2010 The Regents of the University of Michigan and
  The European Organization for Nuclear Research (CERN). Licensed under the
  Educational Community License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may
  obtain a copy of the License at

  http://www.osedu.org/licenses/ECL-2.0

  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an "AS IS"
  BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
  or implied. See the License for the specific language governing
  permissions and limitations under the License.
  ==================================================================== </%doc>
<%inherit file="/base.mako" />
<%def name="title_tag()">
	<title>Micala - Monitoring overview</title>
</%def>
<%def name="js_import()">
    <script src="/js/monitor.js" type="text/javascript"></script>
</%def>
<%def name="title_page()">
	Monitoring overview
</%def>
<br />
<div>
    <form onSubmit="return false;">
    <table class="monitorFilter" cellpadding="2" cellspacing="1" align="center">
        <tr>
            <td width="100" valign="top" class="monitorFilterTitle">FILTERS</td>
            <td valign="top">
                <div class="monitorFilterTitle">Age:</div>
                <div>
                    <input type="hidden" id="filterAgeLectureOld" value="${filterAgeLecture}" />
                    <input type="text" name="filterAgeLecture" id="filterAgeLecture" value="${filterAgeLecture}" size="7">
                    &nbsp;<button id="btnFilterAgeLecture">Filter</button>
                </div>
            </td>
            <td valign="top">
                <%
                selectedWebLecture = ''
                selectedPlainVideo = ''
                selectedAny = ''
                if filterContentType == confContentTypeWebLecture:
                    selectedWebLecture = 'checked="checked"'
                elif filterContentType == confContentTypePlainVideo:
                    selectedPlainVideo = 'checked="checked"'
                else:
                    selectedAny = 'checked="checked"'
                %>
                <div class="monitorFilterTitle">Lecture type:</div>
                <div id="radioFilterContentType">
                    <input type="radio" id="filterContentTypeAny" name="radioContentType" value="-1" ${selectedAny} /><label for="filterContentTypeAny" onClick="setChecked('#filterContentTypeAny');">Any</label>
                    <input type="radio" id="filterContentTypeWebLecture" name="radioContentType" value="${confContentTypeWebLecture}" ${selectedWebLecture} /><label for="filterContentTypeWebLecture" onClick="setChecked('#filterContentTypeWebLecture');">Web Lecture</label>
                    <input type="radio" id="filterContentTypePlainVideo" name="radioContentType" value="${confContentTypePlainVideo}" ${selectedPlainVideo} /><label for="filterContentTypePlainVideo" onClick="setChecked('#filterContentTypePlainVideo');">Plain Video</label>
                </div>
            </td>
            <td valign="top">
                <%
                selectedOrphan = ''
                selectedNonOrphan = ''
                selectedAny = ''
                if filterOrphanStatus == 1:
                    selectedOrphan = 'checked="checked"'
                elif filterOrphanStatus == 0:
                    selectedNonOrphan = 'checked="checked"'
                else:
                    selectedAny = 'checked="checked"'
                %>
                <div class="monitorFilterTitle">Orphan status:</div>
                <div id="radioFilterOrphanStatus">
                    <input type="radio" id="filterOrphanStatusAny" name="radioOrphanStatus" value="-1" ${selectedAny} /><label for="filterOrphanStatusAny" onClick="setChecked('#filterOrphanStatusAny');">Any</label>
                    <input type="radio" id="filterOrphanStatusOrphan" name="radioOrphanStatus" value="1" ${selectedOrphan} /><label for="filterOrphanStatusOrphan" onClick="setChecked('#filterOrphanStatusOrphan');">Orphan</label>
                    <input type="radio" id="filterOrphanStatusNonOrphan" name="radioOrphanStatus" value="0" ${selectedNonOrphan} /><label for="filterOrphanStatusNonOrphan" onClick="setChecked('#filterOrphanStatusNonOrphan');">Non-orphan</label>
                </div>
            </td>
            <td valign="top">
                <%
                selectedFinished = ''
                selectedNotFinished = ''
                selectedAny = ''
                if filterFinished == 1:
                    selectedFinished = 'checked="checked"'
                elif filterFinished == 0:
                    selectedNotFinished = 'checked="checked"'
                else:
                    selectedAny = 'checked="checked"'
                %>
                <div class="monitorFilterTitle">Processing:</div>
                <div id="radioFilterFinished">
                    <input type="radio" id="filterFinishedAny" name="radioFinished" value="-1" ${selectedAny} /><label for="filterFinishedAny" onClick="setChecked('#filterFinishedAny');">Any</label>
                    <input type="radio" id="filterFinishedTrue" name="radioFinished" value="1" ${selectedFinished} /><label for="filterFinishedTrue" onClick="setChecked('#filterFinishedTrue');">Finished</label>
                    <input type="radio" id="filterFinishedFalse" name="radioFinished" value="0" ${selectedNotFinished} /><label for="filterFinishedFalse" onClick="setChecked('#filterFinishedFalse');">Not finished</label>
                </div>
            </td>
            <td style="border: 0;" align="center" class="monitorFilterTitle">Lectures found: <span id="showNumLectures"></span></td>
        </tr>
    </table>
    </form>
</div>
<br />
<div id="loadingMonitorList" style="display: none;"><img src="/images/loadingBig.gif" alt="loading" title="loading" /></div>
<div id="monitorList"></div>
<br /><br />