<%doc> ====================================================================
  Copyright (c) 2010 The Regents of the University of Michigan and
  The European Organization for Nuclear Research (CERN). Licensed under the
  Educational Community License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may
  obtain a copy of the License at

  http://www.osedu.org/licenses/ECL-2.0

  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an "AS IS"
  BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
  or implied. See the License for the specific language governing
  permissions and limitations under the License.
  ==================================================================== </%doc>
<%
from micala import Common
import conf
numLectures = 0
row = 0
%>
% if listLectures:
    <table width="100%" cellpadding="2" cellspacing="1" class="monitoringList">
    <tr class="header">
        <td></td>
        <td align="center">Lecture Object ID <a href="#" onClick="updateMonitorListSorted('LOID', 'ASC');"><img src="/images/sortAscending.png" alt="Sort Ascending" title="Sort Ascending" style="margin-left: 8px; vertical-align: middle;" /></a><a href="#" onClick="updateMonitorListSorted('LOID','DESC');"><img src="/images/sortDescending.png" alt="Sort Descending" title="Sort Descending" style="margin-left: 2px; vertical-align: middle;" /></a></td>
        <td align="center">Indico ID <a href="#" onClick="updateMonitorListSorted('IndicoID', 'ASC');"><img src="/images/sortAscending.png" alt="Sort Ascending" title="Sort Ascending" style="margin-left: 8px; vertical-align: middle;" /></a><a href="#" onClick="updateMonitorListSorted('IndicoID','DESC');"><img src="/images/sortDescending.png" alt="Sort Descending" title="Sort Descending" style="margin-left: 2px; vertical-align: middle;" /></a></td>
        <td align="center">Duration <a href="#" onClick="updateMonitorListSorted('Duration', 'ASC');"><img src="/images/sortAscending.png" alt="Sort Ascending" title="Sort Ascending" style="margin-left: 8px; vertical-align: middle;" /></a><a href="#" onClick="updateMonitorListSorted('Duration','DESC');"><img src="/images/sortDescending.png" alt="Sort Descending" title="Sort Descending" style="margin-left: 2px; vertical-align: middle;" /></a></td>
        <td align="center">Recording room</td>
        <td align="center">Date Created <a href="#" onClick="updateMonitorListSorted('DateCreated', 'ASC');"><img src="/images/sortAscending.png" alt="Sort Ascending" title="Sort Ascending" style="margin-left: 8px; vertical-align: middle;" /></a><a href="#" onClick="updateMonitorListSorted('DateCreated','DESC');"><img src="/images/sortDescending.png" alt="Sort Descending" title="Sort Descending" style="margin-left: 2px; vertical-align: middle;" /></a></td>
        <td align="center">Tasks Status</td>
    % for lecture in listLectures:
        <% (flagFinished, dictLectureLatestStatus) = Common.getLectureLatestStatus(lecture["LOID"], listTasks, listStatuses) %>
        % if (filterFinished == 0 and flagFinished == False) or (filterFinished == 1 and flagFinished == True) or filterFinished == -1:
        <tr class="row${row}" id="tr_lecture_${lecture["idLecture"]}" onClick="toggleDetails('${lecture["idLecture"]}', '${lecture["LOID"]}'); return false;">
            <td id="td_lecture_${lecture["idLecture"]}" width="12" class="showDetails"></td>
            <%
            numLectures += 1
            if not lecture.has_key("LOID") or lecture["LOID"] is None:
                lecture["LOID"] = 'N/A'
            lectureIndicoID=''
            if not lecture.has_key("IndicoID") or lecture["IndicoID"] is None:
                if lecture["ContentType"] == confContentTypeWebLecture:
                    lecture["IndicoID"] = "orphan"
                if lecture["ContentType"] == confContentTypePlainVideo:
                    lecture["IndicoID"] = "none"
            else:
                lectureIndicoID = Common.getConfId(lecture["IndicoID"])
            if not lecture.has_key("CDSRecord") or lecture["CDSRecord"] is None:
                lecture["CDSRecord"] = 'none'
            if not lecture.has_key("Duration") or lecture["Duration"] is None:
                lecture["Duration"] = 'TBD'
            else:
                if lecture["Duration"] < 0:
                    lecture["Duration"] = '<span class="monitorDurationError">ERROR</span>'
                if lecture["Duration"] < 300:
                    lecture["Duration"] = '<span class="monitorDurationAttention">' + Common.formatDuration(lecture["Duration"]) + '</span>'
                else:
                    lecture["Duration"] = Common.formatDuration(lecture["Duration"])
            if not lecture.has_key("DateCreated") or lecture["DateCreated"] is None:
                lecture["DateCreated"] = ''
            %>
            <td>${lecture["LOID"]}</td>
            <td align="center">
                ${lecture["IndicoID"]}
            </td>
            <td align="center">${lecture["Duration"]}</td>
            <td align="center">
                ${dictLectureLatestStatus["recording"]["room"]}
            </td>
            <td align="center">${lecture["DateCreated"]}</td>
            <td align="center">
                % for task in listTasks:
                <%
                img = 'statusBlank'
                alt = 'N/A'
                if dictLectureLatestStatus[task["Name"]]["status"] == "START":
                    if task["Name"] == "metadata export to CDS":
                        img = 'statusPending'
                        alt = task["Name"] + ': PENDING'
                    else:
                        img = 'statusRunning'
                        alt = task["Name"] + ': IN PROGRESS'
                elif dictLectureLatestStatus[task["Name"]]["status"] == "RUNNING":
                    img = 'statusRunning'
                    alt = dictLectureLatestStatus[task["Name"]]["message"]
                elif dictLectureLatestStatus[task["Name"]]["status"] == "COMPLETE":
                    img = 'statusComplete'
                    alt = task["Name"] + ': DONE'
                elif dictLectureLatestStatus[task["Name"]]["status"] == "ERROR":
                    img = 'statusError'
                    alt = task["Name"] + ': ERROR'
                elif dictLectureLatestStatus[task["Name"]]["status"] == "REQUESTED":
                    img = 'statusRequested'
                    alt = task["Name"] + ': REQUESTED'
                %>
                <img src="/images/${img}.png" alt="${alt}" />
                % endfor
        </tr>
        <tr>
            <td colspan="7">
            <div id="lecture_${lecture["idLecture"]}" class="selectedContent">
            <table width="100%" cellpadding="0" cellspacing="0">
            <tr>
            <td class="selected" width="12">&nbsp;</td>
            <td valign="top">
                <table width="100%" cellpadding="0" cellspacing="0">
                    <tr>
                        <td valign="top" align="left">
                            <table cellpadding="2" cellspacing="1" class="monitorListDetails">
                                <tr>
                                    <td width="30%" class="header">Title</td>
                                    <td>${lecture["Title"]}</td>
                                </tr>
                                <tr>
                                    <td class="header">Creator</td>
                                    <td>${lecture["Creator"]}</td>
                                </tr>
                                <tr>
                                    <td class="header">Recording room</td>
                                    <td>${dictLectureLatestStatus["recording"]["room"]}</td>
                                </tr>
                                <tr>
                                    <td class="header">Recording machine</td>
                                    <td>${dictLectureLatestStatus["recording"]["machine"]}</td>
                                </tr>
                                <tr>
                                    <td class="header">Origin path</td>
                                    <td>${lecture["OriginPath"]}</td>
                                </tr>
                                <tr>
                                    <td class="header">Indico ID</td>
                                    <td>
                                        ${lecture["IndicoID"]}
                                        % if lectureIndicoID != '':
                                        <div>
                                        <a href="http://indico.cern.ch/conferenceDisplay.py?confId=${lectureIndicoID}" target="_blank">View on Indico</a><br />
                                        <a href="https://indico.cern.ch/confModifCollaboration.py?tab=Recording+Manager&confId=${lectureIndicoID}" target="_blank">Recording Manager</a>
                                        </div>
                                        % endif
                                    </td>
                                </tr>
                                <tr>
                                    <td class="header" style="border-bottom: 0px;">CDS Record</td>
                                    <td>
                                        ${lecture["CDSRecord"]}
                                        % if lecture["CDSRecord"] != 'none':
                                        <div>
                                        <a href="http://cdsweb.cern.ch/record/${lecture["CDSRecord"]}" target="_blank">CERN Document Server</a>
                                        </div>
                                        % endif
                                    </td>
                                </tr>
                            </table>
                            <div class="monitorViewDetails"><a href="https://${conf.curr_machine}/admin/lectureDetails.py?idLecture=${lecture["idLecture"]}">View details (admin area)</a></div>
                        </td>
                        <td class="border">&nbsp;</td>
                        <td valign="top" align="left" width="40%">
                            <table width="96%" cellpadding="0" cellspacing="1"" class="monitorDetailsTasks">
                            % for task in listTasks:
                                <tr>
                                    <%
                                    content='&nbsp;'
                                    time='&nbsp;'
                                    duration='&nbsp;'
                                    img = 'statusBlank'
                                    alt = 'N/A'
                                    if dictLectureLatestStatus[task["Name"]]["status"] == "START":
                                        if task["Name"] == "metadata export to CDS":
                                            content='PENDING'
                                            img = 'statusPending'
                                            alt = task["Name"] + ': PENDING'
                                        else:
                                            content='IN PROGRESS'
                                            img = 'statusRunning'
                                            alt = task["Name"] + ': IN PROGRESS'
                                        time=Common.formatTaskAge(dictLectureLatestStatus[task["Name"]]["started"])
                                    elif dictLectureLatestStatus[task["Name"]]["status"] == "RUNNING":
                                        content='IN PROGRESS'
                                        img = 'statusRunning'
                                        alt = dictLectureLatestStatus[task["Name"]]["message"]
                                        time=Common.formatTaskAge(dictLectureLatestStatus[task["Name"]]["started"])
                                        if dictLectureLatestStatus[task["Name"]]["message"] != "":
                                            time+=', '+dictLectureLatestStatus[task["Name"]]["message"]
                                    elif dictLectureLatestStatus[task["Name"]]["status"] == "COMPLETE":
                                        content='DONE'
                                        img = 'statusComplete'
                                        alt = task["Name"] + ': DONE'
                                    elif dictLectureLatestStatus[task["Name"]]["status"] == "ERROR":
                                        img = 'statusError'
                                        alt = task["Name"] + ': ERROR'
                                        content='ERROR '+dictLectureLatestStatus[task["Name"]]["message"]
                                    elif dictLectureLatestStatus[task["Name"]]["status"] == "REQUESTED":
                                        content='REQUESTED'
                                        img = 'statusRequested'
                                        alt = task["Name"] + ': REQUESTED'
                                    if dictLectureLatestStatus[task["Name"]]["status"] == "COMPLETE" and dictLectureLatestStatus[task["Name"]].has_key("duration") and dictLectureLatestStatus[task["Name"]]["duration"] != "":
                                        duration=Common.formatDuration(dictLectureLatestStatus[task["Name"]]["duration"])
                                    %>
                                    <td width="29" align="center" class="header"><img src="/images/${img}.png" alt="${alt}" /></td>
                                    <td width="32%" class="row"><b>${task["Name"]}</b></td>
                                    <td class="row">${content}</td>
                                    <td class="row" align="center" width="10%"><span class="taskSmall">${time}</span></td>
                                    <td class="row" align="center" width="20%"><span class="taskSmall">${duration}</span></td>
                                </tr>
                            % endfor
                            </table>
                        </td>
                        <td class="border">&nbsp;</td>
                        <td width="220" valign="top" align="center">
                            <div align="center"><b>Previews</div></p>
                            <div id="lecturePreviews_${lecture["idLecture"]}"></div>
                        </td>

                        </div>
                        </td>
                    </tr>
                </table>
            </td>
            </tr>
            </table>
            </div>
            </td>
        </tr>
        % endif
    <%
    row = numLectures % 2
    %>
    % endfor
    </table>
    % if numLectures == 0:
    <div class="noEntries">No results found. Change filter selection.</div>
    % endif
% else:
<div class="noEntries">No results found. Change filter selection.</div>
% endif
<input type="hidden" id="numLectures" value="${numLectures}" />