<%doc> ====================================================================
  Copyright (c) 2010 The Regents of the University of Michigan and
  The European Organization for Nuclear Research (CERN). Licensed under the
  Educational Community License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may
  obtain a copy of the License at
 
  http://www.osedu.org/licenses/ECL-2.0
 
  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an "AS IS"
  BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
  or implied. See the License for the specific language governing
  permissions and limitations under the License.
  ==================================================================== </%doc>
<%inherit file="/baseAdmin.mako" />
<%def name="title_tag()">
	<title>Micala - Restricted Area - Tasks</title>
</%def>
<%def name="js_import()">
	<script src="/js/task.js" type="text/javascript"></script>
</%def>
<%def name="title_page()">
	Tasks
</%def>
<table>
	<tr>
		<td width="430" valign="top">
			<div class="pageSubTitle"><img src="/images/sortIcon.png" alt="Sort order" title="Sort order" style="vertical-align: middle; margin-right: 5px;" /> Task Ordering</div>
			% if listTasks:
			<div class="listTasksInfo"><a href="#" onClick="sortingGrant();return false;">Click here to enable/disable sorting list</a><br />(drag and drop tasks up/down to sort)</div>
			<ul id="listTasks">
			% for task in listTasks:
				<li class="sortDisabled" id="task_${task["idTask"]}">
					<div id="taskName_${task["idTask"]}" class="taskListRow">
						<table width="300" cellpadding="0" cellspacing="0">
							<tr>
								<td>${task["Name"]}</td>
								<td class="taskListEdit"><img src="/images/editIcon.png" alt="Edit" title="Edit" style="vertical-align: middle;" /> <a href="#" onClick="taskNameShowEdit('${task["idTask"]}', '${task["Name"]}');return false;" />Edit</a></td>
							</tr>
						</table>
					</div>
				</li>
			% endfor
			</ul>
			<div id="resultOrdering">Ordering correctly saved</div>
			% else:
			<div class="noEntries">No tasks still inserted. Insert a new task.</div>
			% endif
			<script type="text/javascript">
				$("#listTasks").sortable({ disabled: true });
			</script>
			<br /><br />
		</td>
		<td class="border">&nbsp;</td>
		<td valign="top">
			<div class="pageSubTitle"><img src="/images/newTask.png" alt="New Task" title="New Task" style="vertical-align: middle; margin-right: 5px;" /> New Task</div>
			<form action="tasks.py" method="post">
			<div class="taskInsertForm">
				<input id="newTaskName" type="text" name="newTaskName" value="Task name" size="30" class="italic" onClick="taskNameInput();" onKeyPress="taskNameInput();" onBlur="taskNameInput();" style="font-style: italic;" />
				% if listTasks:
				insert after
				<select name="taskAfter">
					<option value="0" />--- As first element ---
				% for task in listTasks:
					<option value="${task["idTask"]}" />${task["Name"]}
				% endfor
				</select>
				% else:
				<input type="hidden" name="taskAfter" value="0" />
				% endif
				<input id="newTaskSubmit" type="submit" name="btnSubmit" value="Insert task" />
				<input type="hidden" name="action" value="insertTask" />
			</div>
			</form>
			<div class="taskInsertCaution">
    			<div class="title"><img src="/images/alert.png" alt="Alert" title="Alert" style="vertical-align: middle; margin-right: 5px;" /> Caution</div>
    			<p>Pay attention when you insert a new task or edit a task name.<br />Do it only if you are aware of the consequences!<br /><br />
    			If you want insert a new task, read this:
    			<ul>
    			     <li>Video processing daemon must be stopped</li>
    			     <li>After inserted the new task, you have to wait few minutes that some data of the database will be re-generated</li>
    			     <li>When the operation is complete, you can start again the video processing daemon</li>
    			</ul>
    			</p>
			</div>
		</td>
	</tr>
</table>
<div id="confirmBox" title="Sort tasks" class="infoBox">
Are you sure you want to change sort order of tasks?
<div align="center"><b>IMPORTANT</b></div>
When you drag and drop tasks, the database is immediately altered!
</div>
<div id="editTaskNameBox" title="Change task name" class="errorBox">
Are you sure you want to change the name of this task?
<div align="center"><b>IMPORTANT</b></div>
Warning: NEVER DO THIS unless you understand what you are doing. Task names are hard-coded in many places and changing the name here will cause things to break.
</div>