# ====================================================================
# Copyright (c) 2010 The Regents of the University of Michigan and
# The European Organization for Nuclear Research (CERN). Licensed under the
# Educational Community License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may
# obtain a copy of the License at
#
# http://www.osedu.org/licenses/ECL-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an "AS IS"
# BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing
# permissions and limitations under the License.
# ====================================================================

from optparse import OptionParser
import MySQLdb
import subprocess
import os
import sys
import time
import shutil
import glob
import re
import time
import calendar
import conf
from micala import Common

def main(args):
    Common.pr(1, "micala daemon started.\n")

    pythonEXE = "\\Python25\\Python.exe "

    script_convert = pythonEXE + os.path.join(conf.micalaHome, "micala\\processing\\bin\\webcast2lectureobject.py --flatten --verbosity=1 --debug=0")
    script_get_lo  = os.path.join(conf.micalaHome, "micala\\processing\\bin\\get_lo.pl -q")
    script_upload  = os.path.join(conf.micalaHome, "micala\\processing\\bin\\upload_lo.pl")
    script_install_metadata = pythonEXE + os.path.join(conf.micalaHome, "micala\\processing\\bin\\install_metadata.py --verbosity=1 --debug=0")

    while True:
        Common.syscom(script_install_metadata)
        Common.syscom(script_convert)
        Common.syscom(script_install_metadata)
        Common.syscom(script_get_lo)
        Common.syscom(script_install_metadata)
        my_wait(10)
        Common.syscom(script_install_metadata)
        my_wait(10)
        Common.syscom(script_install_metadata)
        Common.syscom(script_upload)
        Common.syscom(script_install_metadata)
        my_wait(10)

def my_wait(seconds):
    for i in range(0, int(seconds) - 1):
        # Show message once every 5 seconds
        if i % 5 == 0:
            Common.pr(1, "    sleeping, ok to break with CONTROL-C now. Next command to be executed in %d seconds.\n" % (int(seconds) - i), log_this=False)
        time.sleep(1)

if __name__ == "__main__":
    main(sys.argv[1:])
