<html>
  <head>
    <title>Lecture Object Metadata Editor</title>
  </head>
  <body>
<?php
/* ====================================================================
 * Copyright (c) 2010 The Regents of the University of Michigan and
 * The European Organization for Nuclear Research (CERN). Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
  ==================================================================== */

$flag_submit = 0;
if ($_POST['submit'] == 'submit final') {
  $flag_submit = 1;
}

$flag_autofill = 0;
if ($_POST['submit'] == 'autofill') {
//  echo "autofilling submission!<br>\n";
  $flag_autofill = 1;
}

$tags_metadata = array('id', 
                       'cern_agenda_id',
		       'title', 
		       'creator', 
		       'affiliation', 
		       'directory', 
		       'description', 
                       'duration',
		       'date', 
		       'time', 
		       'location_room',
		       'location_institution',
		       'location_city',
		       'location_tgnid',

);

$tags_formatting = array('upload',
                       'viewer_realplayer', 
                       'viewer_ipod',
		       'viewer_flash', 
                       'use_cwis_metadata',
                       'auto_analyze_slides',
		       'style', 
		       'done_url',
);

$list_styles = array('default', 
		     'atlas', 
                     'atlascomp',
                     'satmorn2003',
);


$lo_base = '/home/mscribe';
$lo_location = $_GET['lo_location'];
$lo_dir = $lo_base . '/' . $lo_location;
$list_lo_locations = array('recording', 'queued', 'uploaded');

//////////////////////////////////////////////////////////
// Collect and display basic information about given lecture object
//
//
//////////////////////////////////////////////////////////
$recording_lo             = $_GET['recording_lo'];
$template_lecture_xml     = 'template-lecture.xml';
$template_metadata_xml    = 'template-metadata.xml';
$template_formatting_xml  = 'template-formatting.xml';
$path_templates           = '/home/mscribe/settings';

echo "<h4>Editing Lecture Object: <tt>" . $lo_dir . '/' . $recording_lo . "</tt></h4>\n";

$metadata_lo_basic = parse_lo_name($recording_lo);

$lo_formatted_time = date('H:i:s', $metadata_lo_basic['timestamp']);
$lo_formatted_date = date('d F Y (l)', $metadata_lo_basic['timestamp']);
$lo_formatted_time_monthday = date('d-M (D)', $metadata_lo_basic['timestamp']);
$lo_formatted_time_day = date('l', $metadata_lo_basic['timestamp']);
$lo_weekday = date('w', $metadata_lo_basic['timestamp']);

$lo_avi_size = get_lo_avi_size("$lo_dir/$recording_lo");
$lo_numslides = get_lo_numslides("$lo_dir/$recording_lo");

echo "date recording made: $lo_formatted_date at $lo_formatted_time<br>\n";
echo "size of master.avi: " . human_readable($lo_avi_size) . ",&nbsp;&nbsp;&nbsp;";
echo "slides captured: $lo_numslides<br>\n";

$metadata_lo = array();
//////////////////////////////////////////////////////////
//
// FIRST PASS
//
//////////////////////////////////////////////////////////
if(! $flag_submit) {

  // Try to get metadata from metadata.xml
  // If it doesn't exist, then try to guess based on time etc
  $metadata_lo = get_metadata($lo_dir, $recording_lo, $tags_metadata, $path_templates, $template_metadata_xml);
  $formatting = get_formatting_metadata($lo_dir, $recording_lo, 
	$tags_formatting, $path_templates, $template_formatting_xml);
//  echo "<br><br>\n";

//  foreach ($formatting as $key=>$value) {
//    echo "$key: $value<br>\n";
//  }


// Took out the entire metadata/lecture.xml stuff.  Only using formatting.xml now
//
// ================================================================ 

//  if ($metadata_lo['found'] == 1) {
//    echo "existing metadata found in lecture object<br>\n";
//  }
//  else {
//    echo "no existing metadata found in LO or template; using guessed values...<br>\n";
//    
////    $metadata_lo = guess_metadata($recording_lo);
//  }
//  
  echo "<table>\n";
  echo "<form method=\"post\" action=\"edit_metadata.php?recording_lo=$recording_lo&lo_location=$lo_location\">\n";
//  foreach ($metadata_lo as $key => $value) {
//    if ($key != 'found') { // don't display 'found' key because it's for internal use
//      echo "<tr>\n";
//      echo "<td>$key</td>";
//      if ($flag_autofill) { // the autofill button was pressed last time, so use those values
//        $value = $_POST['submit_' . $key];
//        if ($key == 'duration') {
//          // (in case recording stopped while editing)
//          $lo_location_new = find_lo($lo_base, $recording_lo);
//          $value = guess_duration("$lo_base/$lo_location_new", $recording_lo);
//        }
//	else {
//          // value is already defined, so leave it
//        }
//        echo "<td><input name=\"submit_$key\" type=\"text\" value=\"$value\" size=\"30\"></td>";
//      }
//      else {
//        echo "<td><input name=\"submit_$key\" type=\"text\" value=\"$value\" size=\"30\"></td>";
//      }
//      if ($key == 'duration') {
////        echo "<td><input type=\"submit\" name=\"submit\" value=\"autofill\"></td>\n";
//      }
//      echo "</tr>\n";
//    }
//  }

// Took out the entire metadata/lecture.xml stuff.  Only using formatting.xml now
//
// ================================================================ 

  // insert a blank line between metadata and formatting info
  echo "<tr><td>&nbsp;</td><td></td><td></td></tr>\n";

  foreach ($formatting as $key => $value) {
    echo "<tr>";
    echo "<td>$key</td>";

    if ($flag_autofill) { // the autofill button was pressed last time, so use those values
      if ($field_is_boolean($key)) {
        if ($_POST['submitformatting_' . $key] != '') {
          $value = 'true';
        }
        else {
          $value = 'false';
        }
      }
      else {
        $value = $_POST['submitformatting_' . $key];
      }
    }
    if (field_is_boolean($key)) {
      $is_checked = '';
      if ($value == 'true') {
        $is_checked = "checked=\"checked\"";
      }
      echo "<td><input type=\"checkbox\" name=\"submitformatting_$key\" $is_checked></td>\n";
    }
    else if ($key == 'style') {
      echo "<td>";
      echo "<select name=\"submitformatting_$key\">\n";
      foreach ($list_styles as $curr_option) {
        $is_selected = '';
        if ($curr_option == $value) {
          $is_selected = 'selected';
        }
        echo "<option value=\"$curr_option\" $is_selected>$curr_option</option>\n";
      }
      echo "</select>\n";
      echo "</td>";
//        echo "<td><input name=\"submitformatting_$key\" type=\"text\" value=\"$value\" size=\"30\"></td>";

    }
    else {
        echo "<td><input name=\"submitformatting_$key\" type=\"text\" value=\"$value\" size=\"30\"></td>";

    }


    echo "<td></td>";
    echo "</tr>";
  
  }
  echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
  echo "<tr><td colspan=\"2\"><input type=\"submit\" name=\"submit\" value=\"submit final\"></td></tr>\n";
//  echo "<input type=\"hidden\" name=\"submit\" value=\"true\">";
  echo "</form>\n";
  echo "</table>\n";


} 

//////////////////////////////////////////////////////////
//
// SECOND PASS
//
//////////////////////////////////////////////////////////
else {
  // retrieving POST data
  echo "<br>\n";
  echo "retrieving metadata post data...<br>\n";
  foreach ($tags_metadata as $tag) {
    $metadata_lo[$tag] = $_POST['submit_' . $tag];
    echo "$tag: <tt>" . $metadata_lo[$tag] . "</tt><br>\n";
  }
  echo "<br>\n";
  echo "retrieving formatting post data...<br>\n";
  foreach ($tags_formatting as $tag) {
    $raw_value = $_POST['submitformatting_' . $tag];

    // translate 'on' and '' to 'true' and 'false' for writing to XML
    if (field_is_boolean($tag)) {
      if ($raw_value == 'on') {
        $formatting[$tag] = 'true';
      }
      else {
        $formatting[$tag] = 'false';
      }
    }
    else {
      $formatting[$tag] = $raw_value;
    }

    echo "$tag: <tt>" . $formatting[$tag] . "</tt><br>\n";
  }
  echo "<br>\n";

  ///////////////////////////////////////////////////////
  //
  // reading lecture.xml template
  //
  echo "reading XML template files...<br>\n";
  $slurp_lecture_xml = file_get_contents("$path_templates/$template_lecture_xml");

  // the title in lecture.xml looks different from metadata.xml
  $slurp_lecture_xml = preg_replace('/LECTURE\s+TITLE=\"[^\"]*\"/',
				    "LECTURE TITLE=\"" . $metadata_lo['title'] . "\"",
				    $slurp_lecture_xml);
  
  // the author (creator) also looks different
  $tag_author = preg_replace('/([^,]*),\s*(.*)/',
			     "$2 $1",
			     $metadata_lo['creator']);
  $slurp_lecture_xml = preg_replace('/<AUTHOR>[^<]*<\/AUTHOR>/i',
				    "<AUTHOR>$tag_author</AUTHOR>",
				    $slurp_lecture_xml);

  // now replace all other submitted tags
  foreach ($metadata_lo as $tag => $value) {
    
    $pattern = '/' . "<($tag)>" . '[^<]*' . "<\/($tag)>" . '/i';

    //    echo "trying to replace <tt>$pattern</tt> with <tt><$tag>$value</$tag></tt><br>\n";
    $slurp_lecture_xml = preg_replace($pattern, "<$1>$value</$2>", $slurp_lecture_xml);
  }

  ///////////////////////////////////////////////////////
  //
  // Now do metadata.xml
  //
  $slurp_metadata_xml = file_get_contents("$path_templates/$template_metadata_xml");
  foreach ($metadata_lo as $tag => $value) {
    
    $pattern = '/' . "<($tag)>" . '[^<]*' . "<\/($tag)>" . '/i';

    //    echo "trying to replace <tt>$pattern</tt> with <tt><$tag>$value</$tag></tt><br>\n";
    $slurp_metadata_xml = preg_replace($pattern, "<$1>$value</$2>", $slurp_metadata_xml);
  }

  ///////////////////////////////////////////////////////
  //
  // Now do formatting.xml
  //
  $slurp_formatting_xml = file_get_contents("$path_templates/$template_formatting_xml");

  foreach ($formatting as $tag => $value) {

//    $pattern = "/<($tag)>.*?<\/($tag)>"; // this pattern doesn't work for some reason
    $pattern = '/' . "<($tag)>" . '[^<]*' . "<\/($tag)>" . '/i';

    $slurp_formatting_xml = preg_replace($pattern, "<$1>$value</$2>", $slurp_formatting_xml);
  }

  // the lecture object may have been moved while the php window was still open
  // So before writing, find it.
  echo "locating lecture object $recording_lo...";
  $lo_location_new = find_lo($lo_base, $recording_lo);
  if ($lo_location_new) {
    echo " found in $lo_location_new.<br>\n";
  }

  echo "<br>\n";
  echo "replacing metadata tags...<br>\n";
  echo "<br>\n";

  $file_lecture_xml = $lo_base . '/' . $lo_location_new . '/' . $recording_lo . '/lecture.xml';
//  file_put_contents($file_lecture_xml, $slurp_lecture_xml);// turned off metadata.xml for now because CWIS does this (herrj@umich.edu, 28 Aug 2008)

  $file_metadata_xml = $lo_base . '/' . $lo_location_new . '/' . $recording_lo . '/metadata.xml';
//  file_put_contents($file_metadata_xml, $slurp_metadata_xml);// turned off metadata.xml for now because CWIS does this (herrj@umich.edu, 28 Aug 2008)

  $file_formatting_xml = $lo_base . '/' . $lo_location_new . '/' . $recording_lo . '/formatting.xml';
  file_put_contents($file_formatting_xml, $slurp_formatting_xml); 

  // writing metadata.xml to /tmp
  echo "writing XML files to Lecture Object...<br>\n";


}

/////////////////////////////////////////////////////////////
// find_lo
//
//
/////////////////////////////////////////////////////////////
function find_lo($lo_base, $recording_lo)
{
  global $list_lo_locations;

  foreach ($list_lo_locations as $curr_dir) {
    if (is_dir("$lo_base/$curr_dir/$recording_lo")) {
      return $curr_dir;
      break;
    }
  }

  echo "error: could not find $recording_lo<br>\n";
}

/////////////////////////////////////////////////////////////
// get_metadata
// 
// 1. initialize metadata array
// 2. if there is a metadata.xml file in the lecture object,
//    get the metadata from that (overwriting everything done in 1.)
// 3. if not, get the metadata from the template metadata.xml file
// 4. then make guesses on certain values
/////////////////////////////////////////////////////////////
function get_metadata($lo_dir, $lo, $list_tags, $path_templates, $template_metadata_xml)
{

  global $flag_autofill;

  $path_lecture_xml  = "$lo_dir/$lo/lecture.xml";
  $path_metadata_xml = "$lo_dir/$lo/metadata.xml";
  $path_template_metadata_xml = "$path_templates/$template_metadata_xml";
  $slurp_metadata = '';
  $metadata = array();


  // 1. initialize $metadata assoc. array first with empty values,
  //    then figure out what the basic metadata should be like date etc
  foreach ($list_tags as $tag) {
    $metadata[$tag] = '';
  }

  // 2. If metadata.xml file found in LO, get metadata from that
  if (is_readable($path_metadata_xml) ) {
    $slurp_metadata = file_get_contents($path_metadata_xml);
    $metadata['found'] = 1;

    foreach ($list_tags as $tag) {
      $a = stripos($slurp_metadata, '<' . $tag . '>', 0);
      $b = stripos($slurp_metadata, '</' . $tag . '>', 0);
      
      //      echo "$tag: [" . substr($slurp_metadata, $a + strlen('<' . $tag . '>'), $b - $a - strlen('<' . $tag . '>')) . "]<br>\n";

      $metadata[$tag] = substr($slurp_metadata, $a + strlen('<' . $tag . '>'), $b - $a - strlen('<' . $tag . '>'));
    }

    //    print_r($metadata);
    echo "<br><br>\n";

    return $metadata;
  }

  // 3. If template metadata.xml file exists, get metadata from that
  if (is_readable($path_template_metadata_xml) ) {
    $slurp_metadata = file_get_contents($path_template_metadata_xml);
    $metadata['found'] = 1;

    foreach ($list_tags as $tag) {
      $a = stripos($slurp_metadata, '<' . $tag . '>', 0);
      $b = stripos($slurp_metadata, '</' . $tag . '>', 0);
      
      //      echo "$tag: [" . substr($slurp_metadata, $a + strlen('<' . $tag . '>'), $b - $a - strlen('<' . $tag . '>')) . "]<br>\n";

      $metadata[$tag] = substr($slurp_metadata, $a + strlen('<' . $tag . '>'), $b - $a - strlen('<' . $tag . '>'));
    }

    //    print_r($metadata);
    echo "<br><br>\n";

  }


  // 4. make guesses on certain values
  $basic_metadata = array();

  $basic_metadata = parse_lo_name($lo);
  $lo_day = date('l', $basic_metadata['timestamp']);
  $lo_mon = date('M', $basic_metadata['timestamp']);

  $formatted_date_plain  = sprintf("%04d%02d%02d", $basic_metadata['year'], 
				   $basic_metadata['month'],
				   $basic_metadata['day']);
  $formatted_date_dashes = sprintf("%04d-%02d-%02d", $basic_metadata['year'], 
				   $basic_metadata['month'],
				   $basic_metadata['day']);
  $formatted_date_nice = sprintf("%02d %s %04d", 
				 $basic_metadata['day'],
				 $lo_mon,
				 $basic_metadata['year']);
  $formatted_time = sprintf("%02d:%02d:%02d", $basic_metadata['hour'], 
			    $basic_metadata['minute'], 
			    $basic_metadata['second']);


  $pattern_200710 = '/^(\d\d\d\d)(\d\d)(\d\d)\-(\w+)\-(\d\d)(\d\d)(\d\d)/';
  if ( preg_match($pattern_200710, $lo, $matches) ) {
    $metadata['id']        = $lo;
  }
  else {
    $metadata['id']          = $formatted_date_plain . '-' . $basic_metadata['wlcd'] . '-' . '00';
  }
  $metadata['date']        = $formatted_date_dashes;
  $metadata['time']        = $formatted_time;

  $metadata['duration'] = guess_duration($lo_dir, $lo);

  return $metadata;

}

function get_lo_avi_size($path_lo)
{
  $file_video_master = $path_lo . '/media/master.avi';
  //  echo "get_lo_avi_size: getting size of $file_video_master";
  return filesize($file_video_master);
}

function human_readable( $size )
{
  $count = 0;
  $format = array("B","KB","MB","GB","TB","PB","EB","ZB","YB");
  while(($size/1024)>1 && $count<8)
    {
      $size=$size/1024;
      $count++;
    }
  if( $size < 10 ) $decimals = 1;
  else $decimals = 0;
  $return = number_format($size,$decimals,'.',' ')." ".$format[$count];
  return $return;
}

function get_lo_numslides( $path_lo )
{
  $dir_slides = $path_lo . '/slides-capture';
  $ctr_file = 0;

  if ($handle = opendir($dir_slides)) {
    while (false !== ($file = readdir($handle))) {
      if ($file != '.' && $file != '..') {
	$ctr_file++;
      }
    }
    closedir($handle);
  }

  return $ctr_file;
}

//////////////////////////////////////////////////
// guess_duration
//
// guess duration of L.O. by looking at 
// time stamps on first and last slides
//////////////////////////////////////////////////
function guess_duration($lo_dir, $lo)
{
  $dir_slides = "$lo_dir/$lo/slides-capture";

  echo "trying to open $dir_slides<br>\n";
  $slide_first = '';
  if (is_dir($dir_slides)) {
    $list_files = scandir($dir_slides);
      foreach ($list_files as $file_curr) {
//        echo("file: $file_curr<br>\n");
        if ($slide_first == '' && preg_match('/(\d+)\.\w+$/', $file_curr, $matches)) {
          $slide_first = $matches[1];
        }
        if (preg_match('/(\d+)\.\w+$/', $file_curr, $matches)) {
  	  $slide_last = $matches[1];
        }
      }
  }

//  echo ("first slide: $slide_first<br>\n");
//  echo ("last slide:  $slide_last<br>\n");

  $pattern_slide = '/^(\d\d\d\d)(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)$/';
  if (preg_match($pattern_slide, $slide_first, $matches)) {
    $time_first_year = $matches[1];
    $time_first_mon  = $matches[2];
    $time_first_day  = $matches[3];
    $time_first_hour = $matches[4];
    $time_first_min  = $matches[5];
    $time_first_sec  = $matches[6];
  }
  if (preg_match($pattern_slide, $slide_last, $matches)) {
    $time_last_year = $matches[1];
    $time_last_mon  = $matches[2];
    $time_last_day  = $matches[3];
    $time_last_hour = $matches[4];
    $time_last_min  = $matches[5];
    $time_last_sec  = $matches[6];
  }
  $time_first = mktime($time_first_hour, 
         $time_first_min, 
         $time_first_sec, 
         $time_first_mon, 
         $time_first_day, 
         $time_first_year);
  $time_last = mktime($time_last_hour, 
         $time_last_min,
         $time_last_sec,
         $time_last_mon,
         $time_last_day,
         $time_last_year);
  $time_duration = $time_last - $time_first;
  $duration_hour = floor($time_duration / 3600);
  $duration_min  = floor(($time_duration - 3600 * $duration_hour) / 60);
  $duration_sec  = $time_duration % 60;
  $duration = sprintf("%02d:%02d:%02d", 
          $duration_hour, $duration_min, $duration_sec);

  return $duration;
}

//////////////////////////////////////////////////
// guess_metadata
//
//
//////////////////////////////////////////////////
function guess_metadata($lo)
{
  $metadata = array();
  $basic_metadata = array();

  $basic_metadata = parse_lo_name($lo);
  $lo_day = date('l', $basic_metadata['timestamp']);
  $lo_mon = date('M', $basic_metadata['timestamp']);

  $formatted_date_plain  = sprintf("%04d%02d%02d", $basic_metadata['year'], 
				   $basic_metadata['month'],
				   $basic_metadata['day']);
  $formatted_date_dashes = sprintf("%04d-%02d-%02d", $basic_metadata['year'], 
				   $basic_metadata['month'],
				   $basic_metadata['day']);
  $formatted_date_nice = sprintf("%02d %s %04d", 
				 $basic_metadata['day'],
				 $lo_mon,
				 $basic_metadata['year']);
  $formatted_time = sprintf("%02d:%02d:%02d", $basic_metadata['hour'], 
			    $basic_metadata['minute'], 
			    $basic_metadata['second']);

  $metadata['title']                = '';
  $metadata['creator']              = '';
  $metadata['directory']            = '';
  $metadata['description']          = '';
  $metadata['location_room']        = '';
  $metadata['location_institution'] = '';
  $metadata['location_city']        = '';
  $metadata['location_tgnid']       = '';
  $metadata['duration']             = '';
  $metadata['cern_agenda_id']       = '';
  $metadata['cern_agenda_id']       = '';

  $pattern_200710 = '/^(\d\d\d\d)(\d\d)(\d\d)\-(\w+)\-(\d\d)(\d\d)(\d\d)/';
  if ( preg_match($pattern_200710, $lo, $matches) ) {
    $metadata['id']        = $lo;
  }
  else {
    $metadata['id']          = $formatted_date_plain . '-' . $basic_metadata['wlcd'] . '-' . '00';
  }
  $metadata['date']        = $formatted_date_dashes;
  $metadata['time']        = $formatted_time;

#  if ($basic_metadata['wlcd'] == 'umwlcd0007' || $basic_metadata['wlcd'] == 'umwlcd0008') {
#    if ($lo_day == 'Monday' || $lo_day == 'Wednesday') {
#      // psych111 happens mon/wed at 10:00
#      if ($basic_metadata['hour'] == 10) {
#	$metadata['title']       = 'Lecture #NN';
#	$metadata['creator']     = 'Malley, Brian';
#	$metadata['directory']   = 'umich/courses/2006-D/psych111';
#	$metadata['description'] = 'Psychology 111 Fall 2006';
#	$metadata['location_room'] = 'Modern Languages Building 1200 (Aud 3)';
#      }
#      // amcult 219 happens mon/wed at 16:00
#      else if ($basic_metadata['hour'] == 16) {
#	$metadata['title']       = 'Lecture #NN';
#	$metadata['creator']     = 'Conforth, Bruce';
#	$metadata['directory']   = 'umich/courses/2006-D/amcult219';
#	$metadata['description'] = 'American Culture 219 Fall 2006';
#	$metadata['location_room'] = 'Angell Hall Auditorium D';
#      }
#    }
#    
#    if ($lo_day == 'Tuesday' || $lo_day == 'Thursday') {
#      // amcult100 happens tue/thu at 11:30
#      if ($basic_metadata['hour'] == 11 || $basic_metadata['hour'] == 12) {
#	$metadata['title']       = 'Lecture #NN';
#	$metadata['creator']     = 'Daubenmier, Judith';
#	$metadata['directory']   = 'umich/courses/2006-D/amcult100';
#	$metadata['description'] = 'American Culture 100 Fall 2006';
#	$metadata['location_room'] = 'Modern Languages Building 2011';
#      }
#      // histart112 happens tue/thu at 17:30
#      else if ($basic_metadata['hour'] == 17 || $basic_metadata['hour'] == 18) {
#	$metadata['title']       = 'Lecture #NN';
#	$metadata['creator']     = 'Biro, Matthew';
#	$metadata['directory']   = 'umich/courses/2006-D/histart112';
#	$metadata['description'] = 'History of Art 112 Fall 2006';
#	$metadata['location_room'] = 'Angell Hall Auditorium D';
#      }
#    }
#  }
#  else if ($basic_metadata['wlcd'] == 'umwlcd0009') {
#    $metadata['directory'] = 'umich/mscribe/bioinf';
#    $metadata['location_room'] = 'Palmer Commons Building 2036';
#  }
  
  return $metadata;
}

//////////////////////////////////////////////////////
// get_formatting_metadata
//
// Description: This function will look for formatting.xml in the LO 
// and read in all fields listed in $tags_formatting.  If this file
// does not exist in the LO, it will get the values in the template file
//
// Returns: an associative array with the following keys:
//   viewer_realplayer, viewer_flash, viewer_ipod, style, donelink
//////////////////////////////////////////////////////
function get_formatting_metadata($lo_dir, $lo, $tags_formatting, 
	$path_templates, $template_formatting_xml)
{
  $formatting = array();

  if (is_readable("$lo_dir/$lo/formatting.xml")) {
    $slurp_file = file_get_contents("$lo_dir/$lo/formatting.xml");
    foreach ($tags_formatting as $tag) {
      if (preg_match("/<$tag>(.*?)<\/$tag>/", $slurp_file, $matches)) {
        $formatting[$tag] = $matches[1];
      }
      else {

        $formatting[$tag] = 'no val in LO';
      }
    }
  }
  // no file in LO, so load default values from template file
  else if (is_readable("$path_templates/$template_formatting_xml") ){ 
    $slurp_template = file_get_contents("$path_templates/$template_formatting_xml");
    foreach ($tags_formatting as $tag) {
      if (preg_match("/<$tag>(.*?)<\/$tag>/", $slurp_template, $matches)) {
        $formatting[$tag] = $matches[1];
      }
      else {
        $formatting[$tag] = 'no val in template';
      }
    }
  }
  // no formatting.xml found in LO, and no template,
  // so pick some default values
  else {
    $formatting['viewer_realplayer']   = 'true'; 
    $formatting['viewer_ipod']         = 'false';
    $formatting['viewer_flash']        = 'false';
    $formatting['use_cwis_metadata']   = 'false';
    $formatting['auto_analyze_slides'] = 'false';
    $formatting['style']               = 'default';
    $formatting['done_url']            = '';
  }

  return ($formatting);
}

//////////////////////////////////////////////////////
// parse_lo_name
//
// Description: Extracts the date, time and wlcd name 
// out of the lo name string, accepting LO names either
// of the type YYYYMMDDHHMMSS_umwlcd0006 or YYYYMMDD_umwlcd0010_HHMMSS
//
// Returns: an associative array containing:
//   year, month, day, hour, minute, second, timestamp
//////////////////////////////////////////////////////
function parse_lo_name($lo)
{

  $metadata_basic = array();

  $pattern_old = '/^\d\d\d\d\d\d\d\d\d\d\d\d\d\d_/';
  $pattern_200710 = '/^(\d\d\d\d)(\d\d)(\d\d)\-(\w+)\-(\d\d)(\d\d)(\d\d)/';
  if( preg_match($pattern_old, $lo) ) {

  $metadata_basic['year']      = substr($lo,  0, 4);
  $metadata_basic['month']     = substr($lo,  4, 2);
  $metadata_basic['day']       = substr($lo,  6, 2);
  $metadata_basic['hour']      = substr($lo,  8, 2);
  $metadata_basic['minute']    = substr($lo, 10, 2);
  $metadata_basic['second']    = substr($lo, 12, 2);
  $metadata_basic['wlcd']      = substr($lo, 15);
  $metadata_basic['timestamp'] = strtotime($metadata_basic['year']
					   . '-' . $metadata_basic['month']
					   . '-' . $metadata_basic['day']
					   . ' ' . $metadata_basic['hour']
					   . ':' . $metadata_basic['minute']
					   . ':' . $metadata_basic['second']);
  }
  else if( preg_match($pattern_200710, $lo, $matches) ) {
    $metadata_basic['year']      = $matches[1];
    $metadata_basic['month']     = $matches[2];
    $metadata_basic['day']       = $matches[3];
    $metadata_basic['wlcd']      = $matches[4];
    $metadata_basic['hour']      = $matches[5];
    $metadata_basic['minute']    = $matches[6];
    $metadata_basic['second']    = $matches[7];
    $metadata_basic['timestamp'] = strtotime($metadata_basic['year']
					     . '-' . $metadata_basic['month']
					     . '-' . $metadata_basic['day']
					     . ' ' . $metadata_basic['hour']
					     . ':' . $metadata_basic['minute']
					     . ':' . $metadata_basic['second']);
  }
  else {

  }

  return $metadata_basic;
}

/////////////////////////////////////////////////////////////
// field_is_boolean
//
// Description: check to see if the given metadata field is one of our
// designated true/false fields (so we can make a checkbox)
//
/////////////////////////////////////////////////////////////
function field_is_boolean($field)
{
  if (substr($field, 0, 6) == 'viewer'
        || $field == 'use_cwis_metadata'
        || $field == 'auto_analyze_slides'
        || $field == 'upload') {
    return (1);
  }
  else {
    return (0);
  }

}


?>

<br><br><a href="list_los.php">Back to list of recordings</a>
  </body>
</html>
