// ====================================================================
// Copyright (c) 2010 The Regents of the University of Michigan and
// The European Organization for Nuclear Research (CERN). Licensed under the
// Educational Community License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License. You may
// obtain a copy of the License at
//
// http://www.osedu.org/licenses/ECL-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an "AS IS"
// BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing
// permissions and limitations under the License.
// ====================================================================

var STATUSDELAY = 2000;    // delay for update in msec
var okStatus = true;       // ok to showStatus (when stopped, don't showStatus)

function startLecture(conference) {
    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=StartLecture';
    url += '&conference=' +conference;
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            //tell the user recording has started
            document.getElementById('busy').innerHTML = '<img src="images/busy.gif">&nbsp;&nbsp;Recording in progress...';
            //start updating status
            showStatus();
        }
    }

    xmlhttp.send(null);
}

function stopLecture() {
    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=StopLecture';
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            //tell the user we are stopping
            okStatus = false;
            document.getElementById('busy').innerHTML = '<img src="images/busy_red.gif">&nbsp;&nbsp;Stopping, please wait...';

            document.getElementById('startButton').disabled = 'disabled';

            setTimeout("statusStopped();", 2*STATUSDELAY);
        }
    }

    xmlhttp.send(null);
}

function showStatus() {
    okStatus = true;
    document.getElementById('lectureStatus').style.display = 'inline';
    
    //videoStatus();
    vgaStatus();
}

function statusStopped() {
    document.getElementById('busy').innerHTML = 'Recording stopped. It is safe to start another.';
    document.getElementById('lectureStatus').style.display = 'none';

    document.getElementById('startButton').disabled = '';
}

//function videoStatus() {
//    //no ajax - update src for dvgrab pic
//    document.getElementById('videoPic').src = 'images/video_status.jpg' +'?rnd=' +Math.random();
//
//    setTimeout("videoStatus();", STATUSDELAY);
//}

function vgaStatus() {
    //no ajax - update src for vga pic
    document.getElementById('vgaPic').src = 'images/latest_slide.jpg' +'?rnd=' +Math.random();

    if(okStatus) {
        setTimeout("vgaStatus();", STATUSDELAY);
    }
}

