<html>
<!-- ====================================================================
  Copyright (c) 2010 The Regents of the University of Michigan and
  The European Organization for Nuclear Research (CERN). Licensed under the
  Educational Community License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may
  obtain a copy of the License at
 
  http://www.osedu.org/licenses/ECL-2.0
 
  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an "AS IS"
  BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
  or implied. See the License for the specific language governing
  permissions and limitations under the License.
  ==================================================================== -->
  <head>
    <title>List of Local Recordings</title>
  </head>
  <body>
<h3>List of Local Recordings</h3>
<?php

$threshhold_size_video = 200000000;

$tags_formatting = array('upload',
                       'viewer_realplayer', 
                       'viewer_ipod',
		       'viewer_flash', 
                       'use_cwis_metadata',
                       'auto_analyze_slides',
		       'style', 
		       'done_url'
);

$flag_display_all_recordings = 1;
if ($_GET['display'] == 'short') {
  $flag_display_all_recordings = 0;
  echo "<a href=\"list_los.php?display=full\">click to view all recordings made (including short ones)</a><br>\n";
}
else {
  echo "<a href=\"list_los.php?display=short\">click to view only long recordings</a><br>\n";
}

$list_lo_locations = array('recording', 'queued', 'uploaded');
foreach ($list_lo_locations as $lo_location) {

$lo_dir = '/home/mscribe/' . $lo_location;

$list_draft_lo = array();

if ($handle = opendir($lo_dir)) {
  while (false !== ($file = readdir($handle))) {
    $pattern = '/^\d\d\d\d/';
    if( preg_match($pattern, $file, $matches) && is_dir("$lo_dir/$file")) {
      array_push($list_draft_lo, $file);
    }
  }
  closedir($handle);
}

echo "<hr>";
echo "<h2>$lo_location</h2><br>\n";

if (count($list_draft_lo) > 0) {
  sort($list_draft_lo);

  echo "<table border=\"0\">\n";
  echo "<tr>\n";
  echo "  <th>date</th>\n";
  echo "  <th>time</th>\n";
  echo "  <th>avi size</th>\n";
  echo "  <th>slides</th>\n";
  echo "  <th>LO name</th>\n";
  echo "  <th>duration</th>\n";
  echo "  <th>upload</th>\n";
  echo "  <th>Real</th>\n";
  echo "  <th>Flash</th>\n";
  echo "  <th>iPod</th>\n";
  echo "  <th>use CWIS</th>";
  echo "  <th>auto analyze</th>";
  echo "  <th>style</th>\n";
  echo "  <th>done URL</th>\n";
  echo "</tr>\n";
  foreach (array_reverse($list_draft_lo, true) as $draft_lo) {
  
    $pattern_old = '/^\d\d\d\d\d\d\d\d\d\d\d\d\d\d_/';
    $pattern_200710 = '/^(\d\d\d\d)(\d\d)(\d\d)\-(\w+)\-(\d\d)(\d\d)(\d\d)/';
    if( preg_match($pattern_old, $draft_lo, $matches) ) {
      $draft_lo_year   = substr($draft_lo,  0, 4);
      $draft_lo_month  = substr($draft_lo,  4, 2);
      $draft_lo_day    = substr($draft_lo,  6, 2);
      $draft_lo_hour   = substr($draft_lo,  8, 2);
      $draft_lo_minute = substr($draft_lo, 10, 2);
      $draft_lo_second = substr($draft_lo, 12, 2);
      $draft_lo_wlcd   = substr($draft_lo, 15);
    }
    else if ( preg_match($pattern_200710, $draft_lo, $matches) ) {
      $draft_lo_year   = $matches[1];
      $draft_lo_month  = $matches[2];
      $draft_lo_day    = $matches[3];
      $draft_lo_wlcd   = $matches[4];
      $draft_lo_hour   = $matches[5];
      $draft_lo_minute = $matches[6];
      $draft_lo_second = $matches[7];
    }
    else {
      echo ($draft_lo . " is not a valid LO name<br>\n");
      $flag_bad_lo_name = 1;
      $draft_lo_year   = '0000';
      $draft_lo_month  = '00';
      $draft_lo_day    = '00';
      $draft_lo_hour   = '00';
      $draft_lo_minute = '00';
      $draft_lo_second = '00';
      $draft_lo_wlcd   = '00';
    }
  
    $draft_lo_timestamp = strtotime("$draft_lo_year-$draft_lo_month-$draft_lo_day" 
  				  . " $draft_lo_hour:$draft_lo_minute:$draft_lo_second");
    $draft_lo_formatted_time = date('H:i:s d F Y', $draft_lo_timestamp);
    $draft_lo_formatted_time_monthday = date('d-M (D)', $draft_lo_timestamp);
    $draft_lo_formatted_time_day = date('l', $draft_lo_timestamp);
    $draft_lo_weekday = date('w', $draft_lo_timestamp);

    $draft_lo_avi_size = get_lo_avi_size("$lo_dir/$draft_lo");

  $draft_lo_creator = get_creator("$lo_dir/$draft_lo/metadata.xml");

  $formatting = array();
  $formatting = get_formatting_metadata("$lo_dir/$draft_lo/formatting.xml", $tags_formatting);


    if ($flag_display_all_recordings || $draft_lo_avi_size >= $threshhold_size_video) {
      // don't waste time counting slides that are unnecessary
      $draft_lo_numslides = get_lo_numslides("$lo_dir/$draft_lo");
  
      //  echo "<tr>\n";
      echo "  <tr bgcolor=\"".generate_color($draft_lo_wlcd, $draft_lo_avi_size, $threshhold_size_video)."\">\n";
      //  echo "<table>\n";
      //  echo "<tr>\n";
      //  echo "    <td>$draft_lo</td>\n";
//      echo "    <td>$draft_lo_wlcd</td>\n";
      echo "    <td>$draft_lo_formatted_time_monthday</td>\n";
      echo "    <td>$draft_lo_hour:$draft_lo_minute:$draft_lo_second</td>\n";
      echo "    <td align=\"right\">" . human_readable($draft_lo_avi_size) . "</td>\n";
      echo "    <td align=\"right\">" . $draft_lo_numslides . "</td>\n";
//      echo "    <td align=\"center\">" . $draft_lo_creator . "</td>\n";
      echo "    <td align=\"center\"><a href=\"edit_metadata.php?recording_lo=$draft_lo&lo_location=$lo_location\">" . $draft_lo . "</a></td>\n";
      echo "    <td align=\"right\">" . guess_duration($lo_dir, $draft_lo) . "</td>\n";
      echo "    <td align=\"center\">" . nice_check($formatting['upload']). "</td>\n";
      echo "    <td align=\"center\">" . nice_check($formatting['viewer_realplayer']). "</td>\n";
      echo "    <td align=\"center\">" . nice_check($formatting['viewer_flash']). "</td>\n";
      echo "    <td align=\"center\">" . nice_check($formatting['viewer_ipod']). "</td>\n";
      echo "    <td align=\"center\">" . nice_check($formatting['use_cwis_metadata']). "</td>\n";
      echo "    <td align=\"center\">" . nice_check($formatting['auto_analyze_slides']). "</td>\n";
      echo "    <td align=\"center\">" . $formatting['style']. "</td>\n";
      echo "    <td align=\"center\">" . $formatting['done_url']. "</td>\n";

      //  echo "    <td>" . generate_color($draft_lo_wlcd, $draft_lo_weekday) . " $draft_lo_weekday</td>\n";
      //  echo "</tr>\n";
      //  echo "</table>\n";
      echo "  </td>\n";
      echo "</tr>\n";
    }    
  
  }
  echo "</table>\n";
  echo "<br><br>\n";
}
else {
  echo "no lecture objects found in $lo_dir/<br>\n";
}
}

//////////////////////////////////////////////////////
// get_creator
//
// this function will look for metadata.xml in the LO
// and read in the creator field
//////////////////////////////////////////////////////
function get_creator($file_metadata)
{

  if (is_readable($file_metadata)) {
    $slurp = file_get_contents($file_metadata);
    
    if (preg_match('/\<creator\>(.*?)\,.*?\<\/creator>/', $slurp, $matches)) {
      $creator = $matches[1];
    }
    else {
      $creator = "no creator";
    } 
  }
  else {
    $creator = '--';
  }

  return ($creator);
}


//////////////////////////////////////////////////////
// get_formatting_metadata
//
// 
//////////////////////////////////////////////////////
function get_formatting_metadata($file_formatting, $tags_formatting)
{
  $formatting = array();

  if (is_readable($file_formatting)) {
    $slurp_file = file_get_contents("$file_formatting");
    foreach ($tags_formatting as $tag) {
      if (preg_match("/<$tag>(.*?)<\/$tag>/", $slurp_file, $matches)) {
        $formatting[$tag] = $matches[1];
      }
      else {
        $formatting[$tag] = 'no val';
      }
    }
  }
  else {
    $formatting['upload']              = '--'; 
    $formatting['viewer_realplayer']   = '--'; 
    $formatting['viewer_ipod']         = '--';
    $formatting['viewer_flash']        = '--';
    $formatting['use_cwis_metadata']   = '--';
    $formatting['auto_analyze_slides'] = '--';
    $formatting['style']               = '--';
    $formatting['done_url']            = '--';
  }

  return $formatting;
}

//////////////////////////////////////////////////////
// generate_color
//
//
//////////////////////////////////////////////////////
function generate_color($wlcd, $filesize, $threshhold_size_video)
{
  $color_choice = 'ffffff';
  $subtraction_choice = '333333';

  if ($wlcd == 'umwlcd0004') {
    $color_choice = 'ffffff';
    $subtraction_choice = '333333';
  }
  if ($wlcd == 'umwlcd0006') {
    $color_choice = 'ffffdd';
    $subtraction_choice = '000033';
  }
  else if ($wlcd == 'umwlcd0007') {
    $color_choice = 'ffdddd';
    $subtraction_choice = '003333';
  }
  else if ($wlcd == 'umwlcd0008') {
    $color_choice = 'ddddff';
    $subtraction_choice = '333300';
  }
  else if ($wlcd == 'umwlcd0009') {
    $color_choice = 'ddffdd';
    $subtraction_choice = '330033';
  }

  // now adjust brightness of color choice depending on
  // day of week

  if ($filesize >= $threshhold_size_video) {
    $color_choice = dechex(hexdec($color_choice) - hexdec($subtraction_choice));
  }

  return ('#' . $color_choice);
}

function get_lo_avi_size($path_lo)
{
  $file_video_master = $path_lo . '/media/master.avi';
  //  echo "get_lo_avi_size: getting size of $file_video_master";
  return filesize($file_video_master);
}

function human_readable( $size )
{
  $count = 0;
  $format = array("B","KB","MB","GB","TB","PB","EB","ZB","YB");
  while(($size/1024)>1 && $count<8)
    {
      $size=$size/1024;
      $count++;
    }
  if( $size < 10 ) $decimals = 1;
  else $decimals = 0;
  $return = number_format($size,$decimals,'.',' ')." ".$format[$count];
  return $return;
}

function get_lo_numslides( $path_lo )
{
  $dir_slides = $path_lo . '/slides-capture';
  $ctr_file = 0;

  if ($handle = opendir($dir_slides)) {
    while (false !== ($file = readdir($handle))) {
      if ($file != '.' && $file != '..') {
	$ctr_file++;
      }
    }
    closedir($handle);
  }
  
  return $ctr_file;
}
//////////////////////////////////////////////////////
// nice_check
//
// instead of 'true' or 'false' display a nice check or blank space
//////////////////////////////////////////////////////
function nice_check($string)
{
  if ($string == 'true') {
    return "<img src=\"images/check.png\">";
  }
  else if ($string == 'false') {
    return "";
  }
  else {
    return $string;
  }
}

//////////////////////////////////////////////////
// guess_duration
//
// guess duration of L.O. by looking at 
// time stamps on first and last slides
//////////////////////////////////////////////////
function guess_duration($lo_dir, $lo)
{
  $dir_slides = "$lo_dir/$lo/slides-capture";

//  echo "trying to open $dir_slides<br>\n";
  $slide_first = '';
  if (is_dir($dir_slides)) {
    $list_files = scandir($dir_slides);
      foreach ($list_files as $file_curr) {
//        echo("file: $file_curr<br>\n");
        if ($slide_first == '' && preg_match('/(\d+)\.\w+$/', $file_curr, $matches)) {
          $slide_first = $matches[1];
        }
        if (preg_match('/(\d+)\.\w+$/', $file_curr, $matches)) {
  	  $slide_last = $matches[1];
        }
      }
  }

//  echo ("first slide: $slide_first<br>\n");
//  echo ("last slide:  $slide_last<br>\n");

  $pattern_slide = '/^(\d\d\d\d)(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)$/';
  if (preg_match($pattern_slide, $slide_first, $matches)) {
    $time_first_year = $matches[1];
    $time_first_mon  = $matches[2];
    $time_first_day  = $matches[3];
    $time_first_hour = $matches[4];
    $time_first_min  = $matches[5];
    $time_first_sec  = $matches[6];
  }
  if (preg_match($pattern_slide, $slide_last, $matches)) {
    $time_last_year = $matches[1];
    $time_last_mon  = $matches[2];
    $time_last_day  = $matches[3];
    $time_last_hour = $matches[4];
    $time_last_min  = $matches[5];
    $time_last_sec  = $matches[6];
  }
  $time_first = mktime($time_first_hour, 
         $time_first_min, 
         $time_first_sec, 
         $time_first_mon, 
         $time_first_day, 
         $time_first_year);
  $time_last = mktime($time_last_hour, 
         $time_last_min,
         $time_last_sec,
         $time_last_mon,
         $time_last_day,
         $time_last_year);
  $time_duration = $time_last - $time_first;
  $duration_hour = floor($time_duration / 3600);
  $duration_min  = floor(($time_duration - 3600 * $duration_hour) / 60);
  $duration_sec  = $time_duration % 60;
  $duration = sprintf("%02d:%02d:%02d", 
          $duration_hour, $duration_min, $duration_sec);

  return $duration;
}

?>
  </body>
</html>
