/* ====================================================================
 * Copyright (c) 2010 The Regents of the University of Michigan and
 * The European Organization for Nuclear Research (CERN). Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
  ==================================================================== */
/*
    Tushar Bhatnagar
*/

    var imageWidth = 384;
    var imageHeight = 240;
    
    var UPDATETIME = 1000;    //time in msec between updates of the cam image
    
    //globals used in controls.php for amount of nudge (changed in changeNudge)
    //set to 'a little' nudge to begin with
    var nudgeLeft = -0.1;
    var nudgeRight = 0.1;
    var nudgeUp = 0.1;
    var nudgeDown = -0.1;
    var nudgeZoomIn = 10;
    var nudgeZoomOut = -10;
    //
    
    var MINPAN = -100;
    var MAXPAN = 100;
    var MINTILT = -30;
    var MAXTILT = 30;
    var MINZOOM = 0;
    var MAXZOOM = 1960;
    
    var oktoMove = true;
    var oktoZoom = true;
    
    function checkCam() {
       var xmlhttp = new XMLHttpRequest();

       var url = 'common.php?type=CheckCam';
       url += '&rnd=' + Math.random();
       xmlhttp.open('GET',url,false);
       xmlhttp.send(null);

       var response = xmlhttp.responseText;
       response = response * 1;

       if(response != 0) { //cameras are off
           alert('The cameras are turrned off. Please turn them on (wait a few seconds) and then press OK.');
	   window.location = 'index.php';
       }
       else {}
    }

    function initDev() {
        var xmlhttp = new XMLHttpRequest();

	var url = 'common.php?type=InitDev';
	url += '&rnd=' + Math.random();
	xmlhttp.open('GET',url,false);
	xmlhttp.send(null);
    }
    
    function initCamControls(withControl, zoomAmt) {
        capture();
        moveCam(true, true, true, 0, 0, zoomAmt, false);
        
        if(withControl) {    //with controls
            document.getElementById('topLayer').ondblclick = moveCamPix;
            document.getElementById('sliderContainer').onclick = zoomCam;
        }
        else {               //without controls (takeref.php)
        }
    }
    
    function changeNudge(alot) {
        if(alot) {
            nudgeLeft = -1;
            nudgeRight = 1;
            nudgeUp = 1;
            nudgeDown = -1;
            nudgeZoomIn = 25;
            nudgeZoomOut = -25;
        }
        else {
            nudgeLeft = -0.1;
            nudgeRight = 0.1;
            nudgeUp = 0.1;
            nudgeDown = -0.1;
            nudgeZoomIn = 10;
            nudgeZoomOut = -10;
        }
    }
    
    function moveCamPix(eventData) {
        if(oktoMove) {
            oktoMove = false;
            
            eventData = (eventData) ? eventData : event;
            if (typeof(eventData.offsetX) != "undefined") {
                var x = eventData.offsetX;
                var y = eventData.offsetY;
            }
            else {
                var x = eventData.clientX;
                var y = eventData.clientY;
                var xOff = this.offsetLeft;
                var yOff = this.offsetTop;
                pElement = this.offsetParent;
                while (pElement != null && pElement.nodeType==1) {
                    xOff = xOff + pElement.offsetLeft;
                    yOff = yOff + pElement.offsetTop;
                    pElement = pElement.offsetParent;
                }
                x = x - xOff;
                y = y - yOff;
            }
            
            var xmlhttp = new XMLHttpRequest();
            
            var url = 'common.php?type=PanTiltPix';
            url += '&panpix=' +x;
            url += '&tiltpix=' +y;
            url += '&w=' +imageWidth;
            url += '&h=' +imageHeight;
            url += '&rnd=' +Math.random();
            xmlhttp.open('GET',url,true);
            
            xmlhttp.onreadystatechange = function() {
                if (xmlhttp.readyState == 4) {
                // Your callback code goes here
                    oktoMove = true;
                }
            }
            
            xmlhttp.send(null);
        }
    }
    
    function moveCam(panFlag, tiltFlag, zoomFlag,
                     pan, tilt, zoom,
                     relative) {
        if(oktoMove) {
            oktoMove = false;
            oktoZoom = false;
            
            var xmlhttp = new XMLHttpRequest();
                        
            var url = 'common.php?type=Move';
            url += '&panFlag=' +panFlag;
            url += '&tiltFlag=' +tiltFlag;
            url += '&zoomFlag=' +zoomFlag;
            url += '&pan=' +pan;
            url += '&tilt=' +tilt;
            url += '&zoom=' +zoom;
            url += '&relative=' +relative;
            url += '&rnd=' +Math.random();
            xmlhttp.open('GET',url,true);
            
            xmlhttp.onreadystatechange = function() {
                if (xmlhttp.readyState == 4) {
                    //update zoombar (if zoombar exists)
                    if(document.getElementById('slider')) {
                        if(zoomFlag && !relative) {
                            var y = parseInt(150-((zoom/MAXZOOM)*150));
                            document.getElementById('slider').style.top = y-7 +'px';
                        }
                        if(zoomFlag && relative) {
                            var y = document.getElementById('slider').style.top.replace('px','')/1;
                            y -= parseInt((zoom/MAXZOOM)*150);
                            document.getElementById('slider').style.top = y +'px';
                        }
                    }
                    
                    oktoMove = true;
                    oktoZoom = true;
                }
            }
            
            xmlhttp.send(null);
        }
    }
    
    function zoomCam(eventData) {
        if(oktoZoom) {
            oktoZoom = false;
            
            eventData = (eventData) ? eventData : event;
            
            if (typeof(eventData.offsetX) != "undefined") {
                var y = eventData.offsetY;
            }
            else {
                var y = eventData.clientY;
                var yOff = this.offsetTop;
                pElement = this.offsetParent;
                while (pElement != null && pElement.nodeType==1) {
                    yOff = yOff + pElement.offsetTop;
                    pElement = pElement.offsetParent;
                }
            y = y - yOff;
            }
            
            //convert y to zoom
            var zoomAmt;
            zoomAmt = parseInt(((150-y)/150) * MAXZOOM);

            moveCam(false, false, true, 0, 0, zoomAmt, false);
            document.getElementById('slider').style.top = y-7 +'px';
        }
    }
    
    function getCamPos() {
        if(oktoMove && oktoZoom) {
	    oktoMove = false;
            oktoZoom = false;
			
            var xmlhttp = new XMLHttpRequest();
            
            var url = 'common.php?type=GetPos';
            url += '&rnd=' + Math.random();
            xmlhttp.open('GET',url,true);
            
            xmlhttp.onreadystatechange = function() {
                if (xmlhttp.readyState == 4) {
                    var response = xmlhttp.responseText;
                    var currptzf = new Array();
                    
                    currptzf = response.split(' ');
                    for(var i = 0; i < currptzf.length; i++) {
                        currptzf[i] = currptzf[i] * 1;    //convert to integers
                    }
                    saveCamPosToBoard(currptzf);
                    oktoMove = true;
                    oktoZoom = true;
                }
            }
            
            xmlhttp.send(null);
        }
    }

    function capture() {
        var xmlhttp = new XMLHttpRequest();
        
        var url = 'common.php?type=Capture';
        url += '&rnd=' + Math.random();
        xmlhttp.open('GET',url,true);

        xmlhttp.onreadystatechange = function() {
            if (xmlhttp.readyState == 4) {
            // Your callback code goes here
                document.getElementById('cam').src = 'cam.jpg' + '?rnd=' + Math.random();
                setTimeout("capture()", UPDATETIME);
            }
        }
        
        xmlhttp.send(null);
    }

