<?php
/* ====================================================================
 * Copyright (c) 2010 The Regents of the University of Michigan and
 * The European Organization for Nuclear Research (CERN). Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
  ==================================================================== */

$command = './ptzf -d /dev/ttyMScribeBoard ';

if($_GET['type'] == 'CheckCam') {
    //Check if cameras are on or off
    $command = './checkCam';
}
else if($_GET['type'] == 'InitDev') {
    //Initialize devices here instead of before recording
    $command = './initDev';
}
else if($_GET['type'] == 'PanTiltPix') {
    $command .= '-P ' .$_GET['panpix'] .' '
               .'-T ' .$_GET['tiltpix'] .' '
               .'-w ' .$_GET['w'] .' '
               .'-h ' .$_GET['h'] .' ';
}
else if($_GET['type'] == 'Move') {
    if($_GET['panFlag'] == 'true') $command .= '-p ' .$_GET['pan'] .' ';
    if($_GET['tiltFlag'] == 'true') $command .= '-t ' .$_GET['tilt'] .' ';
    if($_GET['zoomFlag'] == 'true') $command .= '-z ' .$_GET['zoom'] .' ';
    if($_GET['relative'] == 'true') $command .= '-r ';
}
else if($_GET['type'] == 'GetPos') {
    //add nothing to command to get position
}
else if($_GET['type'] == 'Capture') {
    $command = 'vidcat -d /dev/videoMScribeBoard -f jpeg -s 384x240 -i s-video -o cam.jpg';
}
else if($_GET['type'] == 'TakeRef') {
    $command = 'cp -f cam.jpg rooms/' .$_GET['room'] .'.jpg';
}
else if($_GET['type'] == 'SaveBoards') {
    $command = '';    //no command needed
    //write conf file
    $filename = 'rooms/' .$_GET['room'] .'.conf';
    $fp = fopen($filename, 'w');
    $newFileString = str_replace(',', "\n", $_GET['fileString']);
    $write = fputs($fp, $newFileString);
    fclose($fp);
    //
    //add room to rooms.php (if new room)
    if($_GET['newRoom'] == 'true') {
        $filename = 'rooms/rooms.php';
        $fp = fopen($filename, 'a');
        //for alignref
        $string = '    <li><a href="alignref.php?room=' .$_GET['room'];
        $string .= '&newRoom=false';
        $string .= '&prettyRoom=' .$_GET['prettyRoom'] .'">';
        $string .= $_GET['prettyRoom'] .'</a></li>' ."\n";
        //
        $write = fputs($fp, $string);
        fclose($fp);
    }
    //
}
else if($_GET['type'] == 'LoadBoards') {
    $command = 'cat rooms/' .$_GET['room'] .'.conf';
}
else if($_GET['type'] == 'StartTrack') {
    //start tracking script
    $command = '/home/mscribe/bin/trackWrapper start ';
    $command .= $_GET['fstop'];
}
else if($_GET['type'] == 'StopTrack') {
    $command = '/home/mscribe/bin/trackWrapper stop';
}
else if($_GET['type'] == 'StartRecord') {
    //start lecture script
    $command = '/home/mscribe/bin/mscribe start ';
    $command .= $_GET['room'] .' ';
    $command .= '\'' .$_GET['prettyRoom'] .'\'';
}
else if($_GET['type'] == 'StopRecord') {
    $command = '/home/mscribe/bin/mscribe stop'; //stop script here
}
else if($_GET['type'] == 'VideoStatus') {
    $command = 'vidcat -d /dev/videoMScribeDisplay -f jpeg -s 384x240 -i tv -o cam.jpg';
}

$output = shell_exec($command);
echo $output;

?>
