// Tushar Bhatnagar

/* ====================================================================
 * Copyright (c) 2010 The Regents of the University of Michigan and
 * The European Organization for Nuclear Research (CERN). Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
  ==================================================================== */

//global variable for initDev
var initDevRan = false;

//necklace stuff
var fstop = 1.6;	//defaults to old-style necklace: fstop 1.6
					//new-style necklace: fstop 11

function setFStop(newFStop) {
    fstop = newFStop;
}
//

//start/stop tracking stuff
function startTrack() {
    //check if initDev has ran, run if it hasn't already
    if(initDevRan == false) {
        initDev();initDev();
        initDevRan = true;
    }

    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=StartTrack';
    url += '&fstop=' +fstop;
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            //tell the user tracking has started
            document.getElementById('trackStatus').innerHTML = '<img src="images/busy.gif">&nbsp;&nbsp;Tracking has started...';
            
            //enable stop button
            document.getElementById('stopTrack').disabled = '';
            
            //disable start button
            document.getElementById('startTrack').disabled = 'disabled';
        }
    }

    xmlhttp.send(null);
}

function stopTrack() {
    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=StopTrack';
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            //tell the user tracking is stopping
            document.getElementById('trackStatus').innerHTML = '<img src="images/busy_red.gif">&nbsp;&nbsp;Tracking stopping, please wait...';
            
            //disable stop button
            document.getElementById('stopTrack').disabled = 'disabled';

            setTimeout("trackStopped();", STATUSDELAY);
        }
    }

    xmlhttp.send(null);
}

function trackStopped() {
    //tell the user tracking has stopped
    document.getElementById('trackStatus').innerHTML = 'Tracking stopped... it is safe to start the tracking system again.';
    
    //enable start button
    document.getElementById('startTrack').disabled = '';
}
//

//start/stop recording and status stuff
var STATUSDELAY = 2000;    // delay for update in msec
var okStatus = true;       // ok to showStatus (when stopped, don't showStatus)
var numBoards = 0;         // total number of boards sent from board.php

function startRecord(totalNumberBoards) {
    //check if initDev has ran, run if it hasn't already
    if(initDevRan == false) {
        initDev();initDev();
        initDevRan = true;
    }

    numBoards = totalNumberBoards;
    
    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=StartRecord';
    url += '&room=' +room;
    url += '&prettyRoom=' +prettyRoom;
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            //tell the user recording has started
            document.getElementById('recordStatus').innerHTML = '<img src="images/busy.gif">&nbsp;&nbsp;Recording in progress...';
            
            //enable stop button
            document.getElementById('stopRecord').disabled = '';
            
            //disable start button
            document.getElementById('startRecord').disabled = 'disabled';
            
            //start updating status
            showStatus();
        }
    }

    xmlhttp.send(null);
}

function stopRecord() {
    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=StopRecord';
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            //tell the user we are stopping
            okStatus = false;
            document.getElementById('recordStatus').innerHTML = '<img src="images/busy_red.gif">&nbsp;&nbsp;Stopping, please wait...';
            
            //disable stop button
            document.getElementById('stopRecord').disabled = 'disabled';
            
            setTimeout("statusStopped();", 2*STATUSDELAY);
        }
    }

    xmlhttp.send(null);
}

function statusStopped() {
    document.getElementById('recordStatus').innerHTML = 'Recording stopped... it is safe to start another recording.';
    document.getElementById('lectureStatus').style.display = 'none';

    //enable start button
    document.getElementById('startRecord').disabled = '';
}

function showStatus() {
    okStatus = true;

    //enable the right number of boards to show
    if(numBoards == 0) {}
    if(numBoards > 0) {
        document.getElementById('boardPic1').style.display = 'inline';
    }
    if(numBoards > 1) {
        document.getElementById('boardPic2').style.display = 'inline';
    }
    if(numBoards > 2) {
        document.getElementById('boardPic3').style.display = 'inline';
    }
    //
    
    document.getElementById('lectureStatus').style.display = 'inline';
    
    videoStatus();
    boardStatus();
    vgaStatus();
}

function videoStatus() {
    //ajax capture from video 0 composite
    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=VideoStatus';
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            document.getElementById('videoPic').src = 'cam.jpg' + '?rnd=' + Math.random();

            if(okStatus) {
                setTimeout("videoStatus()", STATUSDELAY);
            }
        }
    }

    xmlhttp.send(null);
}

function boardStatus() {
    //no ajax - update src for board pics
    if(numBoards == 0) {}
    if(numBoards > 0) {
        document.getElementById('boardPic1').src = 'images/latest_board_1.jpg' +'?rnd=' +Math.random();
        //document.getElementById('boardPic1').src = 'images/micalalogo.png' +'?rnd=' +Math.random();
    }
    if(numBoards > 1) {
        document.getElementById('boardPic2').src = 'images/latest_board_2.jpg' +'?rnd=' +Math.random();
    }
    if(numBoards > 2) {
        document.getElementById('boardPic3').src = 'images/latest_board_3.jpg' +'?rnd=' +Math.random();
    }

    if(okStatus) {
        setTimeout("boardStatus()", STATUSDELAY);
    }
}

function vgaStatus() {
    //no ajax - update src for vga pic
    document.getElementById('vgaPic').src = 'images/latest_slide.jpg' +'?rnd=' +Math.random();

    if(okStatus) { 
        setTimeout("vgaStatus()", STATUSDELAY);
    }
}
//
