/* ====================================================================
 * Copyright (c) 2010 The Regents of the University of Michigan and
 * The European Organization for Nuclear Research (CERN). Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
  ==================================================================== */

function submitNewRoom() {
    var building = document.getElementById('building').value;
    var roomNum = document.getElementById('roomNum').value;
    window.location = 'takeref.php?building=' +building +'&roomNum=' +roomNum;
}

function takeRef() {
    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=TakeRef';
    url += '&room=' +room;
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);
    
    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            //enable Next button
            document.getElementById('nextButton').disabled="";
        }
    }
    
    xmlhttp.send(null);
}

function toBoardFromRef() {
    //goto board.php
    var url = 'board.php?room=' +room;
    url += '&prettyRoom=' +prettyRoom;
    url += '&newRoom=' +newRoom;
    window.location = url;
}

function getOffset() {
    if(oktoMove && oktoZoom) {
        oktoMove = false;
        oktoZoom = false;

        var xmlhttp = new XMLHttpRequest();

        var url = 'common.php?type=GetPos';
        url += '&rnd=' + Math.random();
        xmlhttp.open('GET',url,true);

        xmlhttp.onreadystatechange = function() {
            if (xmlhttp.readyState == 4) {
                var response = xmlhttp.responseText;
                var currptzf = new Array();

                currptzf = response.split(' ');
                for(var i = 0; i < currptzf.length; i++) {
                    currptzf[i] = currptzf[i] * 1;    //convert to integers
                }
                oktoMove = true;
                oktoZoom = true;
                
                addOffset(currptzf);
            }
        }
        
        xmlhttp.send(null);
    }
}

function addOffset(currptzf) {
    //safe to ignore focus
    var panOff, tiltOff, zoomOff;
    panOff = currptzf[0];
    tiltOff = currptzf[1];
    zoomOff = 100 - currptzf[2];
    
    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=LoadBoards';
    url += '&room=' +room;
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            var response = xmlhttp.responseText;
            var responseArray = new Array();
            responseArray = response.split("\n");
            //convert to ints
            for(var i = 0; i < responseArray.length; i++) {
                responseArray[i] = responseArray[i] * 1;
            }

            //load data to fake boards and add offsets
            var numberOfBoards = responseArray[0];
            var j = 1;
            for(var i = 0; i < numberOfBoards; i++) {
                boardArray[i] = new Board(i);
                boardArray[i].alreadySaved = true;
                //pan adjustments
                if((responseArray[j] + panOff) < MINPAN) {
                    boardArray[i].pan = MINPAN; j++;
                }
                else if((responseArray[j] + panOff) > MAXPAN) {
                    boardArray[i].pan = MAXPAN; j++;
                }
                else boardArray[i].pan = (responseArray[j] + panOff); j++;
                //
                //tilt adjustments
                if((responseArray[j] + tiltOff) < MINTILT) {
                    boardArray[i].tilt = MINTILT; j++;
                }
                else if((responseArray[j] + tiltOff) > MAXTILT) {
                    boardArray[i].tilt = MAXTILT; j++;
                }
                else boardArray[i].tilt = (responseArray[j] + tiltOff); j++;
                //
                //zoom adjustments
                if((responseArray[j] + zoomOff) < MINZOOM) {
                    boardArray[i].zoom = MINZOOM; j++;
                }
                else if((responseArray[j] + zoomOff) > MAXZOOM) {
                    boardArray[i].zoom = MAXZOOM; j++;
                }
                else boardArray[i].zoom = (responseArray[j] + zoomOff); j++;
                //
                boardArray[i].focus = responseArray[j]; j++;
                boardArray[i].x[0] = responseArray[j]; j++;
                boardArray[i].y[0] = responseArray[j]; j++;
                boardArray[i].x[1] = responseArray[j]; j++;
                boardArray[i].y[1] = responseArray[j]; j++;
                boardArray[i].x[2] = responseArray[j]; j++;
                boardArray[i].y[2] = responseArray[j]; j++;
                boardArray[i].x[3] = responseArray[j]; j++;
                boardArray[i].y[3] = responseArray[j]; j++;
            }
            //

            saveOffset();
        }
    }

    xmlhttp.send(null);
}

function saveOffset() {
    var fileString = totalBoards();
    fileString += ",";
    for(var i = 0; i < totalBoards(); i++) {
        fileString += boardArray[i].pan +",";
        fileString += boardArray[i].tilt +",";
        fileString += boardArray[i].zoom +",";
        fileString += boardArray[i].focus +",";
        fileString += boardArray[i].x[0] +",";
        fileString += boardArray[i].y[0] +",";
        fileString += boardArray[i].x[1] +",";
        fileString += boardArray[i].y[1] +",";
        fileString += boardArray[i].x[2] +",";
        fileString += boardArray[i].y[2] +",";
        fileString += boardArray[i].x[3] +",";
        fileString += boardArray[i].y[3] +",";
    }

    var xmlhttp = new XMLHttpRequest();

    var url = 'common.php?type=SaveBoards';
    url += '&fileString=' +fileString;
    url += '&room=' +room;
    url += '&newRoom=' +newRoom;
    url += '&prettyRoom=' +prettyRoom;
    url += '&rnd=' + Math.random();
    xmlhttp.open('GET',url,true);

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState == 4) {
            //do not take a ref image here, it should be done before offsetting the coordinates
	    //now move forward to board.php
	    toBoardFromRef();
        }
    }

    xmlhttp.send(null);
}
